/**
 * ABOUT.js zarafa owncloud plugin
 *
 * Author: Christoph Haas <christoph.h@sprinternet.at>
 * Copyright (C) 2012-2013 Christoph Haas
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

Ext.namespace('Zarafa.plugins.owncloud');

/**
 * @class Zarafa.plugins.owncloud.ABOUT
 * @extends String
 *
 * The copyright string holding the copyright notice for the Zarafa owncloud Plugin.
 */
Zarafa.plugins.owncloud.ABOUT = ""
	+ "<p>Copyright (C) 2012-2013  Christoph Haas &lt;christoph.h@sprinternet.at&gt;</p>"

	+ "<p>This program is free software; you can redistribute it and/or "
	+ "modify it under the terms of the GNU Lesser General Public "
	+ "License as published by the Free Software Foundation; either "
	+ "version 2.1 of the License, or (at your option) any later version.</p>"

	+ "<p>This program is distributed in the hope that it will be useful, "
	+ "but WITHOUT ANY WARRANTY; without even the implied warranty of "
	+ "MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU "
	+ "Lesser General Public License for more details.</p>"

	+ "<p>You should have received a copy of the GNU Lesser General Public "
	+ "License along with this program; if not, write to the Free Software "
	+ "Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</p>"

	+ "<hr />"

	+ "<p>The owncloud plugin contains the following third-party components:</p>"

	+ "<h1>WebDAV Client API</h1>"

	+ "<p>Copyright (C) 2003 Christian Juerges &lt;christian.juerges@xwave.ch&gt;</p>"

	+ "<p>Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the \"Software\"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:</p>"

	+ "<p>The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.</p>"

	+ "<p>THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.</p>"

	+ "<h1>ExtJS ux.Media 2.1.3 extension</h1>"

	+ "<p>Copyright(c) 2007-2010, Active Group, Inc.</p>"

	+ "<p>License: ux.Media classes are licensed under the terms of the Open Source GPL 3.0 license (details: http://www.gnu.org/licenses/gpl.html).</p>";/**
 * ResponseHandler.js zarafa owncloud plugin
 *
 * Author: Christoph Haas <christoph.h@sprinternet.at>
 * Copyright (C) 2012-2013 Christoph Haas
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

Ext.namespace('Zarafa.plugins.owncloud.data');

/**
 * @class Zarafa.plugins.owncloud.data.ResponseHandler
 * @extends Zarafa.core.data.AbstractResponseHandler
 *
 * Owncloud specific response handler.
 */
Zarafa.plugins.owncloud.data.ResponseHandler = Ext.extend(Zarafa.core.data.AbstractResponseHandler, {

	/**
	 * @cgf {String} The id of the opened node in fuile tree recieved from the Owncloud
	 */
	nodeId: undefined,

	/**
	 * @cfg {Function} successCallback The function which
	 * will be called after success request.
	 */
	successCallback : null,
	
	/**
	 * @cfg {Function} failureCallback The function which
	 * will be called after a failed request.
	 */
	failureCallback : null,
	
	/**
	 * Call the successCallback callback function.
	 * @param {Object} response Object contained the response data.
	 */
	doLoaddirectory : function(response) {
		if(response.status == true) {
			this.successCallback(response.items, response);
		} else {
			this.failureCallback(response);
		}
	},
	
	/**
	 * Call the successCallback callback function.
	 * @param {Object} response Object contained the response data.
	 */
	doGetversion : function(response) {
		this.successCallback(response);
	},
	
	/**
	 * Call the successCallback callback function.
	 * @param {Object} response Object contained the response data.
	 */	
	doTmpdownload : function(response) {
		this.successCallback(response.items, response);
	},
	
	/**
	 * Call the successCallback callback function.
	 * @param {Object} response Object contained the response data.
	 */
	doPrepareattachment : function(response) {
		this.successCallback(response);
	},
	
	/**
	 * Call the successCallback callback function.
	 * @param {Object} response Object contained the response data.
	 */
	doCreatedir : function(response) {
		this.successCallback(response);
	},
	
	/**
	 * Call the successCallback callback function.
	 * @param {Object} response Object contained the response data.
	 */
	doUploadtooc : function(response) {
		this.successCallback(response);
	},
	
	/**
	 * Call the successCallback callback function.
	 * @param {Object} response Object contained the response data.
	 */
	doClearcache : function(response) {
		this.successCallback(response);
	},
	
	/**
	 * Call the successCallback callback function.
	 * @param {Object} response Object contained the response data.
	 */
	doMove : function(response) {
		if(response.status == true) {
			this.successCallback(response);
		} else {
			this.failureCallback(response);
		}
	},

	/**
	 * In case exception happened on server, server will return
	 * exception response with the code of exception.
	 * @param {Object} response Object contained the response data.
	 */
	doError: function(response) {
		Zarafa.common.dialogs.MessageBox.show({
			title   : dgettext('plugin_owncloud', 'Error'),
			msg     : response.error.info.original_message,
			icon    : Zarafa.common.dialogs.MessageBox.ERROR,
			buttons : Zarafa.common.dialogs.MessageBox.OK
		});
	}
});

Ext.reg('zarafa.owncloudresponsehandler', Zarafa.plugins.owncloud.data.ResponseHandler);/**
 * DirectoryLoader.js zarafa owncloud plugin
 *
 * Author: Christoph Haas <christoph.h@sprinternet.at>
 * Copyright (C) 2012-2013 Christoph Haas
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

Ext.namespace('Zarafa.plugins.owncloud.data');

/**
 * @class Zarafa.plugins.owncloud.data.DirectoryLoader
 * @extends Ext.tree.TreeLoader
 *
 * Owncloud Directory loader. Extends Ext treeloader to use Zarafa
 * specific requests.
 */
Zarafa.plugins.owncloud.data.DirectoryLoader = Ext.extend(Ext.tree.TreeLoader, {

	/**
	 * also load files
	 */
	files : false,
	
	/**
	 * @constructor
	 * @param {Object} config Configuration object
	 */
	constructor : function(config) {
		config = config || {};
		
		if(undefined !== config.loadfiles)
			this.files = config.loadfiles;

		Ext.applyIf(config, {
			preloadChildren: true,
			directFn : this.loadFolder.createDelegate(this),
			listeners: {
				loadexception: function(tl, node, response) {
					Zarafa.common.dialogs.MessageBox.show({
						title : dgettext('plugin_owncloud', 'Loading failed'),
						msg : response.error,
						icon : Zarafa.common.dialogs.MessageBox.ERROR,
						buttons : Zarafa.common.dialogs.MessageBox.OK
					});
				}
			}
		});

		Zarafa.plugins.owncloud.data.DirectoryLoader.superclass.constructor.call(this, config);
	},

	/**
	 * Will do single request to owncloud module with provided nodeId and
	 * in case of success will load the content of this node.
	 *
	 * @param {Number} nodeId The id of node which content need to be loaded
	 * @param {Function} callback The function which need to be called after response received
	 */
	loadFolder : function(nodeId, callback) {
		var self = this;
		var responseHandler = new Zarafa.plugins.owncloud.data.ResponseHandler({
			successCallback: function(items, response) {
				// reanable upload button Zarafa.plugins.owncloud.ui.UploadButton
				var toolBar = Zarafa.plugins.owncloud.data.ComponentBox.getGridToolbar();
				if(toolBar) {
					var button = toolBar.uploadbutton;
					if(button)
						button.enable();
				}
				
				callback(items, response); // run callback
			},
			failureCallback: function(response) {
				
				var toolBar = Zarafa.plugins.owncloud.data.ComponentBox.getGridToolbar();
				var tabBarItems = Zarafa.plugins.owncloud.data.ComponentBox.getTabPanelItems();
				var openedWindow = Ext.WindowMgr.getActive();
				
				// close the opened dialog
				if(openedWindow)
					openedWindow.close();
				
				// close all opened upload tabs
				var OwncloudUploadContentPanel = container.getSharedComponent(Zarafa.core.data.SharedComponentType['common.create']);
				Ext.each(tabBarItems, function (item) {
					if(item.xtype && item.xtype == "zarafa.ownclouduploadcontentpanel") {
						item.close();
					}
				});
				
				// try to disable Zarafa.plugins.owncloud.ui.UploadButton
				if(toolBar) {
					var button = toolBar.uploadbutton;
					if(button)
						button.disable();
				}
				
				Zarafa.common.dialogs.MessageBox.show({
					title : dgettext('plugin_owncloud', 'Error'),
					msg : response.error,
					icon : Zarafa.common.dialogs.MessageBox.ERROR,
					buttons : Zarafa.common.dialogs.MessageBox.OK
				});
				
				callback(undefined, {status : true, items : undefined}); // run callback
			},
			nodeId: nodeId
		});
		
		container.getRequest().singleRequest(
			'owncloudmodule',
			'loaddirectory',
			{
				id : nodeId,
				loadfiles : this.files
			},
			responseHandler
		);
	}
});/**
 * Version.js zarafa owncloud plugin
 *
 * Author: Christoph Haas <christoph.h@sprinternet.at>
 * Copyright (C) 2012-2013 Christoph Haas
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

Ext.namespace('Zarafa.plugins.owncloud.data');

/**
 * @class Zarafa.plugins.owncloud.data.Version
 * @extends Object
 *
 * Global Version Manager
 */
Zarafa.plugins.owncloud.data.Version = Ext.extend(Object, {
	ocversion : undefined,
	plversion : undefined,
	
	dTask: undefined,
	
	init : function() {
		var responseHandler = new Zarafa.plugins.owncloud.data.ResponseHandler({
			successCallback: this.gotVersion.createDelegate(this)
		});
		
		container.getRequest().singleRequest(
			'owncloudmodule',
			'getversion',
			{
				plugin : "owncloud"
			},
			responseHandler
		);
	},
	
	gotVersion : function(response) {
		this.ocversion = response.ocversion;
		this.plversion = response.version;
	},
	
	getPluginVersion : function() {
		return this.plversion;
	},
	
	getOwncloudVersion : function() {
		if(this.ocversion)
			return this.ocversion;
		else
			return dgettext('plugin_owncloud', 'Unknown');
	}
});

// Make it a singleton
Zarafa.plugins.owncloud.data.Version = new Zarafa.plugins.owncloud.data.Version();/**
 * SettingsOwncloudComponentsWidget.js zarafa owncloud plugin
 *
 * Author: Christoph Haas <christoph.h@sprinternet.at>
 * Copyright (C) 2012-2013 Christoph Haas
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

Ext.namespace('Zarafa.plugins.owncloud.settings');

/**
 * @class Zarafa.plugins.owncloud.settings.SettingsOwncloudComponentsWidget
 * @extends Zarafa.settings.ui.SettingsWidget
 * @xtype Zarafa.plugins.owncloud.settingsowncloudwidget
 *
 * The {@link Zarafa.settings.ui.SettingsWidget widget} for configuring
 * the general owncloud options in the {@link Zarafa.owncloud.settings.SettingsOwncloudComponentsCategory owncloud category}.
 */
Zarafa.plugins.owncloud.settings.SettingsOwncloudComponentsWidget = Ext.extend(Zarafa.settings.ui.SettingsWidget, {

	/**
	 * @constructor
	 * @param {Object} config Configuration object
	 */
	constructor : function(config) {
		config = config || {};

		Ext.applyIf(config, {
			title : dgettext('plugin_owncloud', 'Enable/Disable +%+ components').replace('+%+', container.getSettingsModel().get('zarafa/v1/plugins/owncloud/button_name')),
			layout : 'form',
			items : [{
				xtype : 'checkbox',
				name : 'zarafa/v1/plugins/owncloud/enable_attach_from_oc',
				ref : 'attachFrom',
				fieldLabel : dgettext('plugin_owncloud', 'Attach a file from +%+').replace('+%+', container.getSettingsModel().get('zarafa/v1/plugins/owncloud/button_name')),
				lazyInit : false,
				listeners : {
					check : this.onCheck,
					scope : this
				}
			},
			{
				xtype : 'checkbox',
				name : 'zarafa/v1/plugins/owncloud/enable_store_to_oc',
				ref : 'attachTo',
				fieldLabel : dgettext('plugin_owncloud', 'Save received attachments to +%+').replace('+%+', container.getSettingsModel().get('zarafa/v1/plugins/owncloud/button_name')),
				lazyInit : false,
				listeners : {
					check : this.onCheck,
					scope : this
				}
			},
			{
				xtype : 'checkbox',
				name : 'zarafa/v1/plugins/owncloud/enable_browser',
				ref : 'enableBrowser',
				fieldLabel : dgettext('plugin_owncloud', 'Enable file browser'),
				lazyInit : false,
				listeners : {
					check : this.onCheck,
					scope : this
				}
			}]
		});

		Zarafa.plugins.owncloud.settings.SettingsOwncloudComponentsWidget.superclass.constructor.call(this, config);
	},

	/**
	 * Called by the {@link Zarafa.settings.ui.SettingsCategory Category} when
	 * it has been called with {@link zarafa.settings.ui.SettingsCategory#update}.
	 * This is used to load the latest version of the settings from the
	 * {@link Zarafa.settings.SettingsModel} into the UI of this category.
	 * @param {Zarafa.settings.SettingsModel} settingsModel The settings to load
	 */
	update : function(settingsModel) {
		this.model = settingsModel;
		this.attachFrom.setValue(settingsModel.get(this.attachFrom.name));
		this.attachTo.setValue(settingsModel.get(this.attachTo.name));
		this.enableBrowser.setValue(settingsModel.get(this.enableBrowser.name));
	},

	/**
	 * Called by the {@link Zarafa.settings.ui.SettingsCategory Category} when
	 * it has been called with {@link zarafa.settings.ui.SettingsCategory#updateSettings}.
	 * This is used to update the settings from the UI into the {@link Zarafa.settings.SettingsModel settings model}.
	 * @param {Zarafa.settings.SettingsModel} settingsModel The settings to update
	 */
	updateSettings : function(settingsModel) {
		settingsModel.set(this.attachFrom.name, this.attachFrom.getValue());
		settingsModel.set(this.attachTo.name, this.attachTo.getValue());
		settingsModel.set(this.enableBrowser.name, this.enableBrowser.getValue());
	},

	/**
	 * Event handler called when checkbox has been modified
	 *
	 * @param {Ext.form.CheckBox} checkbox Checkbox element from which the event originated
	 * @param {Boolean} checked State of the checkbox
	 * @private
	 */
	onCheck : function(checkbox, checked) {
		if(this.model) {
			// FIXME: The settings model should be able to detect if
			// a change was applied
			if (this.model.get(checkbox.name) !== checked)
				this.model.set(checkbox.name, checked);
		}
	}
});

Ext.reg('Zarafa.plugins.owncloud.settingsowncloudcomponentswidget', Zarafa.plugins.owncloud.settings.SettingsOwncloudComponentsWidget);
/**
 * SettingsOwncloudWidget.js zarafa owncloud plugin
 *
 * Author: Christoph Haas <christoph.h@sprinternet.at>
 * Copyright (C) 2012-2013 Christoph Haas
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

Ext.namespace('Zarafa.plugins.owncloud.settings');

/**
 * @class Zarafa.owncloud.settings.SettingsOwncloudWidget
 * @extends Zarafa.settings.ui.SettingsWidget
 * @xtype Zarafa.plugins.owncloud.settingsowncloudwidget
 *
 * The {@link Zarafa.settings.ui.SettingsWidget widget} for configuring
 * the general owncloud options in the {@link Zarafa.owncloud.settings.SettingsOwncloudCategory owncloud category}.
 */
Zarafa.plugins.owncloud.settings.SettingsOwncloudWidget = Ext.extend(Zarafa.settings.ui.SettingsWidget, {
	/**
	 * @constructor
	 * @param {Object} config Configuration object
	 */
	constructor : function(config) {
		config = config || {};

		Ext.applyIf(config, {
			title : dgettext('plugin_owncloud', 'General +%+ settings').replace('+%+', container.getSettingsModel().get('zarafa/v1/plugins/owncloud/button_name')),
			layout : 'form',
			items : [{
				xtype : 'textfield',
				name : 'zarafa/v1/contexts/owncloud/server',
				ref : 'serverField',
				fieldLabel : dgettext('plugin_owncloud', 'Server address'),
				emptyText : 'demo.owncloud.org',
				anchor : '100%',
				listeners : {
					change : this.onFieldChange,
					scope : this
				}
			},
			{
				xtype : 'textfield',
				name : 'zarafa/v1/contexts/owncloud/port',
				ref : 'portField',
				fieldLabel : dgettext('plugin_owncloud', 'Server port'),
				emptyText : '80',
				anchor : '100%',
				listeners : {
					change : this.onFieldChange,
					scope : this
				}
			},
			{
				xtype : 'textfield',
				name : 'zarafa/v1/contexts/owncloud/port_ssl',
				ref : 'portsslField',
				fieldLabel : dgettext('plugin_owncloud', 'Server SSL port'),
				emptyText : '443',
				anchor : '100%',
				listeners : {
					change : this.onFieldChange,
					scope : this
				}
			},
			{
				xtype : 'textfield',
				name : 'zarafa/v1/contexts/owncloud/owncloud_path',
				ref : 'pathField',
				fieldLabel : dgettext('plugin_owncloud', 'Path to +%+').replace('+%+', container.getSettingsModel().get('zarafa/v1/plugins/owncloud/button_name')),
				emptyText : '',
				anchor : '100%',
				validator: function(value) {
					if (/.*\/remote\.php\/webdav\/$|.*\/files\/webdav\.php\/$/g.test(value)) {
						return dgettext('plugin_owncloud', 'No trailing slashes!');
					}
					
					return true;
				},				
				listeners : {
					change : this.onFieldChange,
					scope : this
				}
			},
			{
				xtype : 'textfield',
				name : 'zarafa/v1/contexts/owncloud/username',
				ref : 'usernameField',
				fieldLabel : dgettext('plugin_owncloud', 'Username'),
				emptyText : 'test',
				anchor : '100%',
				listeners : {
					change : this.onFieldChange,
					scope : this
				}
			},
			{
				xtype : 'textfield',
				name : 'zarafa/v1/contexts/owncloud/password',
				ref : 'passwordField',
				inputType : 'password',
				fieldLabel : dgettext('plugin_owncloud', 'Password'),
				emptyText : 'test',
				anchor : '100%',
				listeners : {
					change : this.onFieldChange,
					scope : this
				}
			},
			{
				xtype : 'checkbox',
				name : 'zarafa/v1/contexts/owncloud/use_ssl',
				ref : 'useSSL',
				fieldLabel : dgettext('plugin_owncloud', 'Use SSL connections'),
				lazyInit : false,
				listeners : {
					check : this.onCheck,
					scope : this
				}
			}]
		});

		Zarafa.plugins.owncloud.settings.SettingsOwncloudWidget.superclass.constructor.call(this, config);
	},

	/**
	 * Called by the {@link Zarafa.settings.ui.SettingsCategory Category} when
	 * it has been called with {@link zarafa.settings.ui.SettingsCategory#update}.
	 * This is used to load the latest version of the settings from the
	 * {@link Zarafa.settings.SettingsModel} into the UI of this category.
	 * @param {Zarafa.settings.SettingsModel} settingsModel The settings to load
	 */
	update : function(settingsModel) {
		this.model = settingsModel;
		this.serverField.setValue(settingsModel.get(this.serverField.name));
		this.portField.setValue(settingsModel.get(this.portField.name));
		this.portsslField.setValue(settingsModel.get(this.portsslField.name));
		this.pathField.setValue(settingsModel.get(this.pathField.name));
		this.usernameField.setValue(settingsModel.get(this.usernameField.name));
		this.passwordField.setValue(Zarafa.plugins.owncloud.data.Helper.Base64.decode(settingsModel.get(this.passwordField.name)));
		this.useSSL.setValue(settingsModel.get(this.useSSL.name));
		
		if (settingsModel.get(this.useSSL.name) == true) {
			this.portsslField.show();
			this.portsslField.label.show();
			this.portField.hide();
			this.portField.label.hide();
		} else {
			this.portsslField.hide();
			this.portsslField.label.hide();
			this.portField.show();
			this.portField.label.show();
		}
	},

	/**
	 * Called by the {@link Zarafa.settings.ui.SettingsCategory Category} when
	 * it has been called with {@link zarafa.settings.ui.SettingsCategory#updateSettings}.
	 * This is used to update the settings from the UI into the {@link Zarafa.settings.SettingsModel settings model}.
	 * @param {Zarafa.settings.SettingsModel} settingsModel The settings to update
	 */
	updateSettings : function(settingsModel) {
		// We must either set the requested subject, or the default subject
		var server	 = this.serverField.getValue()	 || this.serverField.emptyText;
		var port	 = this.portField.getValue()	 || this.portField.emptyText;
		var portssl	 = this.portsslField.getValue()	 || this.portsslField.emptyText;
		var path	 = this.pathField.getValue()	 || this.pathField.emptyText;
		var username = this.usernameField.getValue() || this.usernameField.emptyText;
		var password = this.passwordField.getValue() || this.passwordField.emptyText;
		
		settingsModel.beginEdit();
		settingsModel.set(this.serverField.name, server);
		settingsModel.set(this.portField.name, port);
		settingsModel.set(this.portsslField.name, portssl);
		settingsModel.set(this.pathField.name, path);
		settingsModel.set(this.usernameField.name, username);
		settingsModel.set(this.passwordField.name, Zarafa.plugins.owncloud.data.Helper.Base64.encode(password));
		settingsModel.set(this.useSSL.name, this.useSSL.getValue());
		settingsModel.endEdit();
	},

	/**
	 * Event handler called when checkbox has been modified
	 *
	 * @param {Ext.form.CheckBox} checkbox Checkbox element from which the event originated
	 * @param {Boolean} checked State of the checkbox
	 * @private
	 */
	onCheck : function(checkbox, checked) {
		if(this.model) {
			// FIXME: The settings model should be able to detect if
			// a change was applied
			if (this.model.get(checkbox.name) !== checked)
				this.model.set(checkbox.name, checked);
		}
		
		if (checked) {
			this.portsslField.show();
			this.portsslField.label.show();
			this.portField.hide();
			this.portField.label.hide();
		} else {
			this.portsslField.hide();
			this.portsslField.label.hide();
			this.portField.show();
			this.portField.label.show();
		}
	},
	
	/**
	 * Event handler which is called when one of the textfields has been changed.
	 * This will apply the new value to the settings (or if the text is empty,
	 * the {@link Ext.form.Field#emptyText} will be saved).
	 * @param {Ext.form.Field} field The field which has fired the event
	 * @param {String} value The new value
	 * @private
	 */
	onFieldChange : function(field, value) {
		if (this.model)
			this.model.set(field.name, value || field.emptyText);
	}
});

Ext.reg('Zarafa.plugins.owncloud.settingsowncloudwidget', Zarafa.plugins.owncloud.settings.SettingsOwncloudWidget);
/**
 * SettingsOwncloudVersionWidget.js zarafa owncloud plugin
 *
 * Author: Christoph Haas <christoph.h@sprinternet.at>
 * Copyright (C) 2012-2013 Christoph Haas
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

Ext.namespace('Zarafa.plugins.owncloud.settings');

/**
 * @class Zarafa.owncloud.settings.SettingsOwncloudVersionWidget
 * @extends Zarafa.settings.ui.SettingsWidget
 * @xtype Zarafa.plugins.owncloud.settingsowncloudwidget
 *
 * The {@link Zarafa.settings.ui.SettingsWidget widget} for configuring
 * the general owncloud options in the {@link Zarafa.owncloud.settings.SettingsOwncloudCategory owncloud category}.
 */
Zarafa.plugins.owncloud.settings.SettingsOwncloudVersionWidget = Ext.extend(Zarafa.settings.ui.SettingsWidget, {
	/**
	 * @constructor
	 * @param {Object} config Configuration object
	 */
	constructor : function(config) {
		config = config || {};
		
		Ext.applyIf(config, {
			title : dgettext('plugin_owncloud', 'Version information'),
			layout : 'form',
			items :[{
				xtype : 'displayfield',
				fieldLabel : dgettext('plugin_owncloud', 'Owncloud'),
				value : Zarafa.plugins.owncloud.data.Version.getOwncloudVersion(),
				htmlEncode : true
			},
			{
				xtype : 'displayfield',
				fieldLabel : dgettext('plugin_owncloud', 'Plugin'),
				value : Zarafa.plugins.owncloud.data.Version.getPluginVersion(),
				htmlEncode : true
			}]
		});

		Zarafa.plugins.owncloud.settings.SettingsOwncloudVersionWidget.superclass.constructor.call(this, config);
	}
});

Ext.reg('Zarafa.plugins.owncloud.settingsowncloudversionwidget', Zarafa.plugins.owncloud.settings.SettingsOwncloudVersionWidget);
/**
 * SettingsOwncloudCategory.js zarafa owncloud plugin
 *
 * Author: Christoph Haas <christoph.h@sprinternet.at>
 * Copyright (C) 2012-2013 Christoph Haas
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

Ext.namespace('Zarafa.plugins.owncloud.settings');

/**
 * @class Zarafa.plugins.owncloud.settings.SettingsOwncloudCategory
 * @extends Zarafa.settings.ui.SettingsCategory
 * @xtype Zarafa.plugins.owncloud.settingsowncloudcategory
 *
 * The owncloud category for users which will
 * allow the user to configure Owncloud related settings
 */
Zarafa.plugins.owncloud.settings.SettingsOwncloudCategory = Ext.extend(Zarafa.settings.ui.SettingsCategory, {
	// Insertion points for this class
	/**
	 * @insert context.settings.category.owncloud
	 * Insertion point to register new {@link Zarafa.settings.ui.SettingsWidget widgets}
	 * for the {@link Zarafa.owncloud.settings.SettingsOwncloudCategory Owncoud Category}.
	 * @param {Zarafa.owncloud.settings.SettingsOwncloudCategory} category The owncloud
	 * category to which the widgets will be added.
	 */

	/**
	 * @constructor
	 * @param {Object} config Configuration object
	 */
	constructor : function(config) {
		config = config || {};

		Ext.applyIf(config, {
			title : container.getSettingsModel().get('zarafa/v1/plugins/owncloud/button_name'),
			categoryIndex : 1,
			iconCls : 'icon_owncloud_category',
			items : [{
				xtype : 'Zarafa.plugins.owncloud.settingsowncloudcomponentswidget'	// enable/disable plugins
			},
			{
				xtype : 'Zarafa.plugins.owncloud.settingsowncloudwidget'			// owncloud specific settings like server address...
			},
			{
				xtype : 'Zarafa.plugins.owncloud.settingsowncloudversionwidget'		// owncloud plugin version
			},
			container.populateInsertionPoint('context.settings.category.owncloud', this)
			]
		});

		Zarafa.plugins.owncloud.settings.SettingsOwncloudCategory.superclass.constructor.call(this, config);
	}
});

Ext.reg('Zarafa.plugins.owncloud.settingsowncloudcategory', Zarafa.plugins.owncloud.settings.SettingsOwncloudCategory);
/**
 * AttachFromOwncloudTreePanel.js zarafa owncloud plugin
 *
 * Author: Christoph Haas <christoph.h@sprinternet.at>
 * Copyright (C) 2012-2013 Christoph Haas
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

Ext.namespace('Zarafa.plugins.owncloud.dialogs');

/**
 * @class Zarafa.plugins.owncloud.dialogs.AttachFromOwncloudTreePanel
 * @extends Ext.tree.TreePanel
 * Shows tree of all user files from Owncloud
 * @xtype Zarafa.plugins.owncloud.attachfromowncloudtreepanel
 */
Zarafa.plugins.owncloud.dialogs.AttachFromOwncloudTreePanel = Ext.extend(Ext.tree.TreePanel, {

	/**
	 * Global Email Record
	 * only set via webdav browser
	 */
	emailRecord : undefined,

	/**
	 * @constructor
	 * @param {Object} config
	 */
	constructor : function(config) {
		config = config || {};
		
		if(typeof config.emailrecord !== "undefined") 
			this.emailRecord = config.emailrecord;
			
		Ext.applyIf(config, {
			root: {
				nodeType: 'async',
				text: '/',
				id: '/',
				expanded : true
			},
			autoScroll: true,
			viewConfig: {
				style : { overflow: 'auto', overflowX: 'hidden' }
			},
			maskDisabled: true,
			loader : new Zarafa.plugins.owncloud.data.DirectoryLoader({loadfiles: true}),
			buttons : [
				this.createActionButtons()
			]
		});
		Zarafa.plugins.owncloud.dialogs.AttachFromOwncloudTreePanel.superclass.constructor.call(this, config);
	},

	/**
	 * Creates action button for adding file
	 * from Owncloud to email as attachment
	 * @return {Array}
	 * @private
	 */
	createActionButtons : function() {
		return [{
			xtype   : 'button',
			text    : '&nbsp;&nbsp;&nbsp;&nbsp;' + dgettext('plugin_owncloud', 'Add attachment'),
			tooltip : {
				title : dgettext('plugin_owncloud', 'Add attachment'),
				text  : dgettext('plugin_owncloud', 'Add selected attachment from owncloud to email attachment.')
			},
			iconCls : 'icon_owncloud_big',
			handler : this.downloadSelectedFilesFromOwncloudToTmp,
			scope   : this
		}];
	},

	/**
	 * Sends a query with ids of selected files from user's Owncloud folder
	 * @private
	 */
	downloadSelectedFilesFromOwncloudToTmp : function() {
		var selectedNodes =  this.getChecked();
		var idsList = [];
		var emailRecord = this.dialog.record;
		
		if(typeof this.emailRecord !== "undefined")
			emailRecord = this.emailRecord;
		
		var attachmentStore = emailRecord.getAttachmentStore();
		var max_file_size = container.getSettingsModel().get('zarafa/v1/main/attachments/max_attachment_size');
		
		var size_exceeded = false;
		
		Ext.each(selectedNodes, function(node, index) {
			if(node.attributes.filesize > max_file_size) {
				Zarafa.common.dialogs.MessageBox.show({
					title : dgettext('plugin_owncloud', 'Warning'),
					msg : dgettext('plugin_owncloud', 'The file +%+ is too large!').replace('+%+', node.attributes.filename) + ' (' + dgettext('plugin_owncloud', 'max') + ': ' + Ext.util.Format.fileSize(max_file_size) + ')',
					icon : Zarafa.common.dialogs.MessageBox.WARNING,
					buttons : Zarafa.common.dialogs.MessageBox.OK
				});
				size_exceeded = true;
				return false;
			}
			idsList.push( node.id );
		});
		
		if(!size_exceeded) {
			if(idsList.length < 1) {
				Zarafa.common.dialogs.MessageBox.show({
					title : dgettext('plugin_owncloud', 'Warning'),
					msg : dgettext('plugin_owncloud', 'You have to choose at least one file!'),
					icon : Zarafa.common.dialogs.MessageBox.WARNING,
					buttons : Zarafa.common.dialogs.MessageBox.OK
				});
			} else {
				try {
					this.disable();
					container.getRequest().singleRequest(
						'owncloudmodule',
						'download-to-tmp',
						{
							ids : idsList,
							dialog_attachments: attachmentStore.getId()
						},
						new Zarafa.plugins.owncloud.data.ResponseHandler({
							successCallback : this.addDownloadedFilesAsAttachmentToEmail.createDelegate(this)
						})
					);
				} catch (e) {
					Zarafa.common.dialogs.MessageBox.show({
						title : dgettext('plugin_owncloud', 'Warning'),
						msg : e.getMessage(),
						icon : Zarafa.common.dialogs.MessageBox.WARNING,
						buttons : Zarafa.common.dialogs.MessageBox.OK
					});
				}
			}
		}
	},

	/**
	 * Converts received file information to attachment record
	 * @param {Object} downloadedFileInfo
	 * @private
	 */
	convertDownloadedFileInfoToAttachmentRecord : function(downloadedFileInfo) {
		var attachmentRecord = Zarafa.core.data.RecordFactory.createRecordObjectByObjectType(Zarafa.core.mapi.ObjectType.MAPI_ATTACH);

		attachmentRecord.set('tmpname', downloadedFileInfo.tmpname);
		attachmentRecord.set('name', downloadedFileInfo.name);
		attachmentRecord.set('size', downloadedFileInfo.size);
		return attachmentRecord;
	},

	/**
	 * Adds files received from the user's Owncloud folder to
	 * the email as attachments
	 * @param {Object} downloadedFilesInfoArray
	 * @private
	 */
	addDownloadedFilesAsAttachmentToEmail : function(downloadedFilesInfoArray) {
		var emailRecord = this.dialog.record;
		if(typeof this.emailRecord !== "undefined")
			emailRecord = this.emailRecord;
			
		var attachmentStore = emailRecord.getAttachmentStore();

		var attachmentRecord = null;
		Ext.each(downloadedFilesInfoArray, function(downloadedFileInfo, index) {
			attachmentRecord = this.convertDownloadedFileInfoToAttachmentRecord(downloadedFileInfo);
			attachmentStore.add(attachmentRecord);
		}, this);
		this.dialog.close();
	}
});

Ext.reg('Zarafa.plugins.owncloud.attachfromowncloudtreepanel', Zarafa.plugins.owncloud.dialogs.AttachFromOwncloudTreePanel);
/**
 * AttachFromOwncloudContentPanel.js zarafa owncloud plugin
 *
 * Author: Christoph Haas <christoph.h@sprinternet.at>
 * Copyright (C) 2012-2013 Christoph Haas
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

Ext.namespace('Zarafa.plugins.owncloud.dialogs');

/**
 * @class Zarafa.plugins.owncloud.dialogs.AttachFromOwncloudContentPanel
 * @extends Zarafa.core.dialogs.ContentPanel
 *
 * The content panel which shows the hierarchy tree of Owncloud account files.
 * @xtype Zarafa.plugins.owncloud.attachfromowncloudcontentpanel
 */
Zarafa.plugins.owncloud.dialogs.AttachFromOwncloudContentPanel = Ext.extend(Zarafa.core.ui.ContentPanel, {

	/**
	 * @cfg {Zarafa.core.data.IPMRecord} record The record to which
	 * we need to add attachment.
	 */
	record : null,

	/**
	 * @constructor
	 * @param config Configuration structure
	 */
	constructor : function(config) {
		config = config || {};
		Ext.applyIf(config, {
			layout : 'fit',
			title : dgettext('plugin_owncloud', '+%+ Attachment').replace('+%+', container.getSettingsModel().get('zarafa/v1/plugins/owncloud/button_name')),
			closeOnSave : true,
			width : 400,
			height : 300,
			//Add panel
			items : [{
				xtype : 'Zarafa.plugins.owncloud.attachfromowncloudtreepanel',
				emailrecord : config.emailrecord,
				ref : 'treePanel'
			}]
		});

		Zarafa.plugins.owncloud.dialogs.AttachFromOwncloudContentPanel.superclass.constructor.call(this, config);
	}
});

Ext.reg('Zarafa.plugins.owncloud.attachfromowncloudcontentpanel', Zarafa.plugins.owncloud.dialogs.AttachFromOwncloudContentPanel);/**
 * SaveToOwncloudTreePanel.js zarafa owncloud plugin
 *
 * Author: Christoph Haas <christoph.h@sprinternet.at>
 * Copyright (C) 2012-2013 Christoph Haas
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

Ext.namespace('Zarafa.plugins.owncloud.dialogs');

/**
 * @class Zarafa.plugins.owncloud.dialogs.SaveToOwncloudTreePanel
 * @extends Ext.tree.TreePanel
 * Shows tree of all user files from Owncloud
 * @xtype Zarafa.plugins.owncloud.savetoowncloudtreepanel
 */
Zarafa.plugins.owncloud.dialogs.SaveToOwncloudTreePanel = Ext.extend(Ext.tree.TreePanel, {

	/**
	 * Holds the selected folder, in which the attachment will be stored
	 */
	selectedFolder : null,
	
	/**
	 * The response object from the content panel
	 */
	response : null,

	/**
	 * @constructor
	 * @param {Object} config
	 */
	constructor : function(config) {
		config = config || {};
		this.response = config.response;
		
		Ext.applyIf(config, {
			root: {
				nodeType: 'async',
				text: '/',
				id: '/',
				expanded : true
			},
			autoScroll: true,
			viewConfig: {
				style	:	{ overflow: 'auto', overflowX: 'hidden' }
			},
			maskDisabled: true,
			listeners: {
				click: function(n) {
					this.selectedFolder = n.attributes.id;
				}
			},
			loader : new Zarafa.plugins.owncloud.data.DirectoryLoader({loadfiles: false}),
			buttons : [
				this.createActionButtons()
			]
		});
		Zarafa.plugins.owncloud.dialogs.SaveToOwncloudTreePanel.superclass.constructor.call(this, config);
	},

	/**
	 * Creates action button for adding file
	 * from Owncloud to email as attachment
	 * @return {Array}
	 * @private
	 */
	createActionButtons : function() {
		return [{
			xtype   : 'button',
			text    : dgettext('plugin_owncloud', 'New folder'),
			tooltip : {
				title   : dgettext('plugin_owncloud', 'New folder'),
				text    : dgettext('plugin_owncloud', 'Create a new folder in') 
			},
			handler : this.newFolder,
			scope   : this
		},
		{
			xtype   : 'button',
			text    : '&nbsp;&nbsp;&nbsp;&nbsp;' + dgettext('plugin_owncloud', 'Save'),
			tooltip : {
				title   : dgettext('plugin_owncloud', 'Store attachment'),
				text    : dgettext('plugin_owncloud', 'Store attachment to the selected +%+ folder.').replace('+%+', container.getSettingsModel().get('zarafa/v1/plugins/owncloud/button_name'))
			},
			iconCls : 'icon_owncloud_big',
			handler : this.uploadFile,
			scope   : this
		}];
	},

	/**
	 * Uploads the prepared attachment to Owncloud
	 * @private
	 */
	uploadFile : function() {
		if(this.selectedFolder == null) {
			Zarafa.common.dialogs.MessageBox.show({
				title   : dgettext('plugin_owncloud', 'Warning'),
				msg     : dgettext('plugin_owncloud', 'You have to choose a folder!'),
				icon    : Zarafa.common.dialogs.MessageBox.WARNING,
				buttons : Zarafa.common.dialogs.MessageBox.OK
			});
		} else {
			try {
				this.disable();
				container.getRequest().singleRequest(
					'owncloudmodule',
					'uploadtooc',
					{
						tmpfile : this.response.tmpname,
						destdir : this.selectedFolder,
						destname : this.response.filename
					},
					new Zarafa.plugins.owncloud.data.ResponseHandler({
						successCallback : this.uploadDone.createDelegate(this)
					})
				);
			} catch (e) {
				Zarafa.common.dialogs.MessageBox.show({
					title   : dgettext('plugin_owncloud', 'Warning'),
					msg     : e.getMessage(),
					icon    : Zarafa.common.dialogs.MessageBox.WARNING,
					buttons : Zarafa.common.dialogs.MessageBox.OK
				});
			}
		}
	},
	
	/**
	 * Upload done =)
	 * @param {Object} response
	 * @private
	 */
	uploadDone : function(response) {
		if(response.status == 201)
			container.getNotifier().notify('info.owncloud', dgettext('plugin_owncloud', 'Uploaded'), dgettext('plugin_owncloud', 'Attachment successfully stored to +%+').replace('+%+', container.getSettingsModel().get('zarafa/v1/plugins/owncloud/button_name')));
		else
			container.getNotifier().notify('error', dgettext('plugin_owncloud', 'Upload Failed'), dgettext('plugin_owncloud', 'Attachment could not be stored in +%+! Error:').replace('+%+', container.getSettingsModel().get('zarafa/v1/plugins/owncloud/button_name')) + ' ' + response.status);

		this.dialog.close();
	},	
	
	/**
	 * Creates a new owncloud folder
	 * @private
	 */
	newFolder : function() {
		if(this.selectedFolder == null) {
			Zarafa.common.dialogs.MessageBox.show({
				title   : dgettext('plugin_owncloud', 'Warning'),
				msg     : dgettext('plugin_owncloud', 'You have to choose a folder!'),
				icon    : Zarafa.common.dialogs.MessageBox.WARNING,
				buttons : Zarafa.common.dialogs.MessageBox.OK
			});
		} else
			Zarafa.common.dialogs.MessageBox.prompt(dgettext('plugin_owncloud', 'Folder Name'), dgettext('plugin_owncloud', 'Please enter a foldername'), this.createRemoteFolder, this);
	},
	
	createRemoteFolder : function(button, text) {
		if(button == "ok") {			
			try {
				container.getRequest().singleRequest(
					'owncloudmodule',
					'createdir',
					{
						dirname : this.selectedFolder + text,
						basedir : this.selectedFolder
					},
					new Zarafa.plugins.owncloud.data.ResponseHandler({
						successCallback : this.createDirDone.createDelegate(this)
					})
				);
			} catch (e) {
				Zarafa.common.dialogs.MessageBox.show({
					title   : dgettext('plugin_owncloud', 'Warning'),
					msg     : e.getMessage(),
					icon    : Zarafa.common.dialogs.MessageBox.WARNING,
					buttons : Zarafa.common.dialogs.MessageBox.OK
				});
			}
		}
	},
	
	/**
	 * createDirDone =)
	 * @param {Object} response
	 * @private
	 */
	createDirDone : function(response) {
		if(response.status == 201) {
			container.getNotifier().notify('info.owncloud', dgettext('plugin_owncloud', 'Created'), dgettext('plugin_owncloud', 'Directory created!'));
			this.getNodeById(response.basedir).reload();
		} else 
			container.getNotifier().notify('error', dgettext('plugin_owncloud', 'Creation failed'), dgettext('plugin_owncloud', 'Directory not created!'));
	}
});

Ext.reg('Zarafa.plugins.owncloud.savetoowncloudtreepanel', Zarafa.plugins.owncloud.dialogs.SaveToOwncloudTreePanel);
/**
 * SaveToOwncloudContentPanel.js zarafa owncloud plugin
 *
 * Author: Christoph Haas <christoph.h@sprinternet.at>
 * Copyright (C) 2012-2013 Christoph Haas
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

Ext.namespace('Zarafa.plugins.owncloud.dialogs');

/**
 * @class Zarafa.plugins.owncloud.dialogs.SaveToOwncloudContentPanel
 * @extends Zarafa.core.ui.ContentPanel
 *
 * The content panel which shows the hierarchy tree of Owncloud account files.
 * @xtype Zarafa.plugins.owncloud.savetoowncloudcontentpanel
 */
Zarafa.plugins.owncloud.dialogs.SaveToOwncloudContentPanel = Ext.extend(Zarafa.core.ui.ContentPanel, {

	/**
	 * @constructor
	 * @param config Configuration structure
	 */
	constructor : function(config) {
		config = config || {};

		Ext.applyIf(config, {
			layout : 'fit',
			title : dgettext('plugin_owncloud', '+%+ Attachment').replace('+%+', container.getSettingsModel().get('zarafa/v1/plugins/owncloud/button_name')),
			closeOnSave : true,
			width : 400,
			height : 300,
			//Add panel
			items : [{
				xtype : 'Zarafa.plugins.owncloud.savetoowncloudtreepanel',
				ref : 'treePanel',
				response : config.record
			}]
		});

		Zarafa.plugins.owncloud.dialogs.SaveToOwncloudContentPanel.superclass.constructor.call(this, config);
	}
});

Ext.reg('Zarafa.plugins.owncloud.savetoowncloudcontentpanel' , Zarafa.plugins.owncloud.dialogs.SaveToOwncloudContentPanel);/**
 * AttachFromOwncloudPlugin.js zarafa owncloud plugin
 *
 * Author: Christoph Haas <christoph.h@sprinternet.at>
 * Copyright (C) 2012-2013 Christoph Haas
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

Ext.namespace('Zarafa.plugins.owncloud');

/**
 * @class Zarafa.plugins.owncloud.OwncloudAttachmentPlugin
 * @extends Zarafa.core.Plugin
 * This class is used for adding files from the users's Owncloud folder
 * to his eownclouds as attachments
 */
Zarafa.plugins.owncloud.AttachFromOwncloudPlugin = Ext.extend(Zarafa.core.Plugin, {

	/**
	 * @constructor
	 * @param {Object} config
	 */
	constructor : function(config) {
		config = config || {};
		Ext.applyIf(config, {
			name : 'attachfromowncloud'
		});
		Zarafa.plugins.owncloud.AttachFromOwncloudPlugin.superclass.constructor.call(this, config);
	},

	/**
	 * initialises insertion point for plugin
	 * @protected
	 */
	initPlugin : function() {
		Zarafa.plugins.owncloud.AttachFromOwncloudPlugin.superclass.initPlugin(this, arguments);
		
		/* load attachments from owncloud */
		this.registerInsertionPoint('main.attachment.method', this.onAttachmentInsertion)
		Zarafa.core.data.SharedComponentType.addProperty('common.dialog.attachments.owncloud');
	},

	/**
	 * Insert owncloud option in all attachment suggestions
	 */
	onAttachmentInsertion : function(include, btn) {
		return {
			text : container.getSettingsModel().get('zarafa/v1/plugins/owncloud/button_name'),
			handler : this.showOwncloudAttachmentDialog.createDelegate(this, [btn]),
			scope: this,
			iconCls: 'icon_owncloud'
		};
	},

	/**
	 * Initializes Dialog for adding attachment from Owncloud to eowncloud
	 * @param {Object} btn
	 * @private
	 */
	showOwncloudAttachmentDialog : function(btn) {
		Zarafa.core.data.UIFactory.openLayerComponent(Zarafa.core.data.SharedComponentType['common.dialog.attachments.owncloud'], btn.record, {
			title : dgettext('plugin_owncloud', 'Add attachment from +%+').replace('+%+', container.getSettingsModel().get('zarafa/v1/plugins/owncloud/button_name')),
			manager : Ext.WindowMgr
		});
	},
	
	/**
	 * Bid for the type of shared component
	 * and the given record.
	 * This will bid on calendar.dialogs.importevents
	 * @param {Zarafa.core.data.SharedComponentType} type Type of component a context can bid for.
	 * @param {Ext.data.Record} record Optionally passed record.
	 * @return {Number} The bid for the shared component
	 */
	bidSharedComponent : function(type, record) {
		var bid = -1;
		
		switch(type) {
			case Zarafa.core.data.SharedComponentType['common.dialog.attachments.owncloud']:
				if (record instanceof Zarafa.core.data.IPMRecord) {
					if (record.supportsAttachments())
						bid = 1;
				}
				break;
		}
		
		return bid;
	},

	/**
	 * Will return the reference to the shared component.
	 * Based on the type of component requested a component is returned.
	 * @param {Zarafa.core.data.SharedComponentType} type Type of component a context can bid for.
	 * @param {Ext.data.Record} record Optionally passed record.
	 * @return {Ext.Component} Component
	 */
	getSharedComponent : function(type, record) {
		var component;

		switch(type) {
			case Zarafa.core.data.SharedComponentType['common.dialog.attachments.owncloud']:
				component = Zarafa.plugins.owncloud.dialogs.AttachFromOwncloudContentPanel;
				break;
		}

		return component;
	}
});/**
 * SaveToOwncloudPlugin.js zarafa owncloud plugin
 *
 * Author: Christoph Haas <christoph.h@sprinternet.at>
 * Copyright (C) 2012-2013 Christoph Haas
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

Ext.namespace('Zarafa.plugins.owncloud');

/**
 * @class Zarafa.plugins.owncloud.OwncloudRcvAttachmentPlugin
 * @extends Zarafa.core.Plugin
 * This class is used for adding files from the users's Owncloud folder
 * to his eownclouds as attachments
 */
Zarafa.plugins.owncloud.SaveToOwncloudPlugin = Ext.extend(Zarafa.core.Plugin, {

	/**
	 * @constructor
	 * @param {Object} config
	 */
	constructor : function(config) {
		config = config || {};
		Ext.applyIf(config, {
			name : 'savetoowncloud'
		});
		Zarafa.plugins.owncloud.SaveToOwncloudPlugin.superclass.constructor.call(this, config);
	},

	/**
	 * initialises insertion point for plugin
	 * @protected
	 */
	initPlugin : function() {
		Zarafa.plugins.owncloud.SaveToOwncloudPlugin.superclass.initPlugin(this, arguments);
		
		/* store attachments in owncloud */
		this.registerInsertionPoint('common.contextmenu.attachment.actions', this.onAttachmentInsertion);
		Zarafa.core.data.SharedComponentType.addProperty('common.dialog.attachments.savetoowncloud');
	},
	
	/**
	 * called on successfull preload of attachment
	 */
	onSuccessPrepare : function(response) {
		Zarafa.common.dialogs.MessageBox.hide();
		Zarafa.core.data.UIFactory.openLayerComponent(Zarafa.core.data.SharedComponentType['common.dialog.attachments.savetoowncloud'], response, {
			title : dgettext('plugin_owncloud', 'Add attachment to +%+').replace('+%+', container.getSettingsModel().get('zarafa/v1/plugins/owncloud/button_name')),
			manager : Ext.WindowMgr
		});
	},

	/**
	 * Insert owncloud option in all attachment suggestions
	 */
	onAttachmentInsertion : function(include, btn) {
		return {
			text : container.getSettingsModel().get('zarafa/v1/plugins/owncloud/button_name'),
			handler : this.prepareAttachment.createDelegate(this, [btn,this.onSuccessPrepare]),
			scope: this,
			iconCls: 'icon_owncloud'
		};
	},

	/**
	 * prepareAttachment
	 * @param {Object} btn
	 * @param {Function} callback
	 * @private
	 */
	prepareAttachment : function(btn,callback) {
	
		Zarafa.common.dialogs.MessageBox.show({
			title: dgettext('plugin_owncloud', 'Please wait'),
			msg: dgettext('plugin_owncloud', 'Loading attachment') + '...',
			progressText: dgettext('plugin_owncloud', 'Initializing') + '...',
			width:300,
			progress:true,
			closable:false
		});

		// progress bar... ;)
		var f = function(v) {
			return function(){
				if(v == 100)
					Zarafa.common.dialogs.MessageBox.hide();
				else
					Zarafa.common.dialogs.MessageBox.updateProgress(v/100, Math.round(v)+'% loaded');
		   };
		};
		
		for(var i = 1; i < 101; i++) {
			setTimeout(f(i), 20*i);
		}
		
		/* store the attachment to a temporary folder and prepare it for uploading */
		var attachmentRecord = btn.records;
		var attachmentStore = attachmentRecord.store;
		
		var store = attachmentStore.getParentRecord().get('store_entryid');
		var entryid = attachmentStore.getAttachmentParentRecordEntryId();
		var attachNum = new Array(1);
		if (attachmentRecord.get('attach_num') != -1)
			attachNum[0] = attachmentRecord.get('attach_num');
		else
			attachNum[0] = attachmentRecord.get('tmpname');
		var dialog_attachments = attachmentStore.getId();
		var filename = attachmentRecord.data.name;
		
		var responseHandler = new Zarafa.plugins.owncloud.data.ResponseHandler({
			successCallback: callback
		});
		
		// request attachment preperation
		container.getRequest().singleRequest(
			'owncloudmodule',
			'prepare-attachment',
			{
				entryid : entryid,
				store: store,
				attachNum: attachNum,
				dialog_attachments: dialog_attachments,
				filename: filename
			},
			responseHandler
		);
	},
	
	/**
	 * Bid for the type of shared component
	 * and the given record.
	 * This will bid on common.dialog.attachments.savetoowncloud
	 * @param {Zarafa.core.data.SharedComponentType} type Type of component a context can bid for.
	 * @param {Object} response Optionally passed response.
	 * @return {Number} The bid for the shared component
	 */
	bidSharedComponent : function(type, response) {
		var bid = -1;
		
		switch(type) {
			case Zarafa.core.data.SharedComponentType['common.dialog.attachments.savetoowncloud']:
				if(response.status == true)
					bid = 1;
				break;
		}
		
		return bid;
	},

	/**
	 * Will return the reference to the shared component.
	 * Based on the type of component requested a component is returned.
	 * @param {Zarafa.core.data.SharedComponentType} type Type of component a context can bid for.
	 * @param {Object} response Optionally passed response.
	 * @return {Ext.Component} Component
	 */
	getSharedComponent : function(type, response) {
		var component;

		switch(type) {
			case Zarafa.core.data.SharedComponentType['common.dialog.attachments.savetoowncloud']:
				component = Zarafa.plugins.owncloud.dialogs.SaveToOwncloudContentPanel;
				break;
		}

		return component;
	}
});/**
 * Helper.js zarafa owncloud plugin
 *
 * Author: Christoph Haas <christoph.h@sprinternet.at>
 * Copyright (C) 2012-2013 Christoph Haas
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
 
Ext.namespace('Zarafa.plugins.owncloud.data');

/**
 * @class Zarafa.plugins.owncloud.data.Helper
 * Some static helper functions 
 * @singleton
 */
Zarafa.plugins.owncloud.data.Helper = {

	/** 
	 * Base64 tools
	 */
	Base64 : {
		// private property
		_keyStr : "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",

		// public method for encoding
		encode : function (input) {
			var output = "";
			var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
			var i = 0;

			input = this._utf8_encode(input);

			while (i < input.length) {

				chr1 = input.charCodeAt(i++);
				chr2 = input.charCodeAt(i++);
				chr3 = input.charCodeAt(i++);

				enc1 = chr1 >> 2;
				enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
				enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
				enc4 = chr3 & 63;

				if (isNaN(chr2))
					enc3 = enc4 = 64;
				else if (isNaN(chr3))
					enc4 = 64;

				output = output +
				this._keyStr.charAt(enc1) + this._keyStr.charAt(enc2) +
				this._keyStr.charAt(enc3) + this._keyStr.charAt(enc4);

			}

			return output;
		},
		
		// public method for decoding
		decode : function (input) {
			var output = "";
			var chr1, chr2, chr3;
			var enc1, enc2, enc3, enc4;
			var i = 0;

			input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");

			while (i < input.length) {

				enc1 = this._keyStr.indexOf(input.charAt(i++));
				enc2 = this._keyStr.indexOf(input.charAt(i++));
				enc3 = this._keyStr.indexOf(input.charAt(i++));
				enc4 = this._keyStr.indexOf(input.charAt(i++));

				chr1 = (enc1 << 2) | (enc2 >> 4);
				chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
				chr3 = ((enc3 & 3) << 6) | enc4;

				output = output + String.fromCharCode(chr1);

				if (enc3 != 64)
					output = output + String.fromCharCode(chr2);
				if (enc4 != 64)
					output = output + String.fromCharCode(chr3);

			}

			output = this._utf8_decode(output);

			return output;

		},
		
		// private method for UTF-8 decoding
		_utf8_decode : function (utftext) {
			var string = "";
			var i = 0;
			var c = 0
			var c1 = 0;
			var c2 = 0;
			var c3 = 0;

			while ( i < utftext.length ) {

				c = utftext.charCodeAt(i);

				if (c < 128) {
					string += String.fromCharCode(c);
					i++;
				}
				else if((c > 191) && (c < 224)) {
					c2 = utftext.charCodeAt(i+1);
					string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
					i += 2;
				}
				else {
					c2 = utftext.charCodeAt(i+1);
					c3 = utftext.charCodeAt(i+2);
					string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
					i += 3;
				}

			}

			return string;
		},

		// private method for UTF-8 encoding
		_utf8_encode : function (string) {
			string = string.replace(/\r\n/g,"\n");
			var utftext = "";

			for (var n = 0; n < string.length; n++) {

				var c = string.charCodeAt(n);

				if (c < 128)
					utftext += String.fromCharCode(c);
				else if((c > 127) && (c < 2048)) {
					utftext += String.fromCharCode((c >> 6) | 192);
					utftext += String.fromCharCode((c & 63) | 128);
				}
				else {
					utftext += String.fromCharCode((c >> 12) | 224);
					utftext += String.fromCharCode(((c >> 6) & 63) | 128);
					utftext += String.fromCharCode((c & 63) | 128);
				}

			}

			return utftext;
		}
	},
	
	/** 
	 * Rendering functions
	 */
	Renderer : {
		
		/**
		 * Typerenderer for folders or files
		 */
		typeRenderer : function(value, p, record) {
			switch (value) {
				case Zarafa.plugins.owncloud.data.FileTypes.FOLDER: p.css = "x-tree-node-icon icon_folder_note"; break;
				case Zarafa.plugins.owncloud.data.FileTypes.FILE: p.css = "x-tree-node-icon icon_folder_task"; break;
				default : break;
			}

			// add extra css class for empty cell
			p.css += ' zarafa-grid-empty-cell';

			return '';
		},
	
		/**
		 * Renders timestamps
		 */
		datetimeRenderer : function(value, p, record) {
			p.css = 'mail_date';

			// # TRANSLATORS: See http://docs.sencha.com/ext-js/3-4/#!/api/Date for the meaning of these formatting instructions
			value = new Date(value);
			return Ext.isDate(value) ? value.format(dgettext('plugin_owncloud', 'l d/m/Y G:i')) : dgettext('plugin_owncloud', 'Never');
		}
	},
	
	/** 
	 * Formatting functions
	 */
	Format : {
		/**
         * Simple format for a file size (xxx bytes, xxx KB, xxx MB)
         * @param {Number/String} size The numeric value to format
         * @return {String} The formatted file size
         */
        fileSize : function(size) {
		    if(size === -1 || size === "none") {
				return dgettext('plugin_owncloud', 'Unknown');
			} else {
				if (size < 1024) {
					return size + " bytes";
				} else if (size < 1048576) {
					return (Math.round(((size*10) / 1024))/10) + " KB";
				} else {
					return (Math.round(((size*10) / 1048576))/10) + " MB";
				}
			}
        }
	}
}/**
 * ComponentBox.js zarafa owncloud plugin
 *
 * Author: Christoph Haas <christoph.h@sprinternet.at>
 * Copyright (C) 2012-2013 Christoph Haas
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
 
Ext.namespace('Zarafa.plugins.owncloud.data');

/**
 * @class Zarafa.plugins.owncloud.data.ComponentBox
 * The global component box which holds all aliases to important components
 * @singleton
 */
Zarafa.plugins.owncloud.data.ComponentBox = Ext.extend(Object, {
	/**
	 * Get the owncloud context
	 */
	getContext : function() {
		// should we return container.getContextByName("owncloudcontext")? performance will be lower...
		return container.getCurrentContext();
	},
	
	/**
	 * Get the owncloud context model
	 */
	getContextModel : function() {
		return this.getContext().getModel();
	},
	
	/**
	 * Get the owncloud gridstore
	 */
	getStore : function() {
		return this.getContextModel().getStore();
	},
	
	/**
	 * Get the navigatorpanel
	 */
	getNavigatorPanel : function() {
		return container.getNavigationBar();
	},
	
	/**
	 * Get the navigator treepanel
	 */
	getNavigatorTreePanel : function() {
		return this.getNavigatorPanel().owncloudTreepanel;
	},
	
	/**
	 * Get the main panel
	 */
	getMainPanel : function() {
		try {
			return container.getContentPanel();
		} catch (e) {
			// this is a workaround for webapps < 1.3
			return container.getTabPanel().getItem(0).getActiveItem();
		}
	},
	
	/**
	 * Get the preview panel
	 */
	getPreviewPanel : function() {
		return this.getMainPanel().owncloudPreview;
	},
	
	/**
	 * Get the tabpanel
	 */
	getTabPanel : function() {
		return container.getTabPanel();
	},
	
	/**
	 * Get the tabpanel items
	 */
	getTabPanelItems : function() {
		return this.getTabPanel().items.items;
	},
	
	/**
	 * Get the owncloud gridpanel
	 */
	getGridPanel : function() {
		return this.getMainPanel().owncloudGridpanel;
	},
	
	/**
	 * Get the owncloud grid toolbar
	 */
	getGridToolbar : function() {
		var gridPanel = this.getGridPanel();
		if(gridPanel)
			return gridPanel.topToolbar;
		else
			return undefined;
	}
});

// make it a singleton
Zarafa.plugins.owncloud.data.ComponentBox = new Zarafa.plugins.owncloud.data.ComponentBox();/**
 * DataModes.js zarafa owncloud plugin
 *
 * Author: Christoph Haas <christoph.h@sprinternet.at>
 * Copyright (C) 2012-2013 Christoph Haas
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

Ext.namespace('Zarafa.plugins.owncloud.data');

/**
 * @class Zarafa.plugins.owncloud.data.DataModes
 * @extends Zarafa.core.Enum
 *
 * Enum containing the different data modes of the owncloud context. 
 * 
 * @singleton
 */
Zarafa.plugins.owncloud.data.DataModes = Zarafa.core.Enum.create({
	/**
	 * View all owncloud items from the selected folder(s).
	 *
	 * @property
	 * @type Number
	 */
	ALL : 0
});
/**
 * FileTypes.js zarafa owncloud plugin
 *
 * Author: Christoph Haas <christoph.h@sprinternet.at>
 * Copyright (C) 2012-2013 Christoph Haas
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

Ext.namespace('Zarafa.plugins.owncloud.data');

/**
 * @class Zarafa.plugins.owncloud.data.FileTypes
 * @extends Zarafa.core.Enum
 *
 * Enum containing the different file types of the owncloud context. 
 * 
 * @singleton
 */
Zarafa.plugins.owncloud.data.FileTypes = Zarafa.core.Enum.create({
	/**
	 * Filetype: folder
	 *
	 * @property
	 * @type Number
	 */
	FOLDER : 0,
	/**
	 * Filetype: file
	 *
	 * @property
	 * @type Number
	 */
	FILE : 1
});
/**
 * ViewModes.js zarafa owncloud plugin
 *
 * Author: Christoph Haas <christoph.h@sprinternet.at>
 * Copyright (C) 2012-2013 Christoph Haas
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

Ext.namespace('Zarafa.plugins.owncloud.data');

/**
 * @class Zarafa.plugins.owncloud.data.ViewModes
 * @extends Zarafa.core.Enum
 *
 * Enum containing the different viewing modes of the owncloud context.
 * 
 * @singleton
 */
Zarafa.plugins.owncloud.data.ViewModes = Zarafa.core.Enum.create({
	/**
	 * Don't show the preview panel
	 * @property
	 * @type Number
	 */
	NO_PREVIEW : 0,

	/**
	 * Show the preview panel to the right
	 * @property
	 * @type Number
	 */
	RIGHT_PREVIEW : 1,

	/**
	 * Show the preview panel in the bottom
	 * @property
	 * @type Number
	 */
	BOTTOM_PREVIEW : 2
});
/**
 * Views.js zarafa owncloud plugin
 *
 * Author: Christoph Haas <christoph.h@sprinternet.at>
 * Copyright (C) 2012-2013 Christoph Haas
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

Ext.namespace('Zarafa.plugins.owncloud.data');

/**
 * @class Zarafa.plugins.owncloud.data.Views
 * @extends Zarafa.core.Enum
 *
 * Enum containing the different views of the owncloud context. 
 * 
 * @singleton
 */
Zarafa.plugins.owncloud.data.Views = Zarafa.core.Enum.create({
	/**
	 * View all owncloud items from the selected folder(s) in the 'list' view.
	 *
	 * @property
	 * @type Number
	 */
	LIST : 0
});
/**
 * Actions.js zarafa owncloud plugin
 *
 * Author: Christoph Haas <christoph.h@sprinternet.at>
 * Copyright (C) 2012-2013 Christoph Haas
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

Ext.namespace('Zarafa.plugins.owncloud.data');

/**
 * @class Zarafa.plugins.owncloud.Actions
 * Common actions which can be used within {@link Ext.Button buttons}
 * or other {@link Ext.Component components} with action handlers.
 * @singleton
 */
Zarafa.plugins.owncloud.data.Actions = {
	/**
	 * The internal 'iframe' which is hidden from the user, which is used for downloading
	 * attachments. See {@link #doOpen}.
	 * @property
	 * @type Ext.Element
	 */
	downloadFrame : undefined,
	
	/**
	 * Converts received file information to attachment record
	 * @param {Object} record
	 * @private
	 */
	convertDownloadedFileInfoToAttachmentRecord : function(record) {
		var attachmentRecord = Zarafa.core.data.RecordFactory.createRecordObjectByObjectType(Zarafa.core.mapi.ObjectType.MAPI_ATTACH);

		attachmentRecord.set('tmpname', record.tmpname);
		attachmentRecord.set('name', record.name);
		attachmentRecord.set('size', record.size);
		return attachmentRecord;
	},
	
	/**
	 * Open a Panel in which a new {@link Zarafa.core.data.IPMRecord record} can be
	 * further edited.
	 *
	 * @param {Zarafa.mail.MailContextModel} model Context Model object that will be used
	 * to {@link Zarafa.mail.MailContextModel#createRecord create} the E-Mail.
	 * @param {Object} config (optional) Configuration object used to create
	 * the Content Panel.
	 */
	openCreateMailContent : function(emailRecord, records, config) {
		var attachmentStore = emailRecord.getAttachmentStore();
		var attachmentRecord = null;
		
		Ext.each(records, function(record, index) {
			attachmentRecord = this.convertDownloadedFileInfoToAttachmentRecord(record);
			attachmentStore.add(attachmentRecord);
		}, this);
		
		Zarafa.core.data.UIFactory.openCreateRecord(emailRecord, config);
	},
	
	/**
	 * Open a Panel in which a new {@link Zarafa.core.data.IPMRecord record} can be
	 * further edited.
	 *
	 * @param {Zarafa.mail.MailContextModel} model Context Model object that will be used
	 * to {@link Zarafa.mail.MailContextModel#createRecord create} the E-Mail.
	 * @param {Object} config (optional) Configuration object used to create
	 * the Content Panel.
	 */
	openCreateMailContentForContacts : function(model, contacts, config) {	
		var emailRecord = container.getContextByName("mail").getModel().createRecord();
		
		Zarafa.core.data.UIFactory.openLayerComponent(Zarafa.core.data.SharedComponentType['zarafa.plugins.owncloud.attachdialog'], undefined , {
			title : dgettext('plugin_owncloud', 'Add attachment from +%+').replace('+%+', container.getSettingsModel().get('zarafa/v1/plugins/owncloud/button_name')),
			emailrecord : emailRecord,
			manager : Ext.WindowMgr
		});
		
		var recipientStore = emailRecord.getRecipientStore();
		var tasks = [];
		
		contacts = Ext.isArray(contacts) ? contacts : [ contacts ];
		for (var i = 0, len = contacts.length; i < len; i++) {
			var contact = contacts[i];

			if (contact.isOpened()) {
				// The contact is opened and contains all the information which we need
				var recipient = contact.convertToRecipient(Zarafa.core.mapi.RecipientType.MAPI_TO, true);
				recipientStore.add(recipient);
			} else {
				// The contact is not opened yet, register a task to open the contact once
				// the panel has been opened.
				tasks.push({
					/* By encapsulating the task function it is possible to get the contact object 
					* into the scope of the task function. When you add more tasks the contact 
					* reference changes and without this encapsulation it will change the contact in
					* all the previously added task functions as well.
					*/
					fn : function(){
						// This contactRecord becomes a private variable, not changable outside.
						var contactRecord = contact;
						return function(panel, record, task, callback) {
							var fn = function(store, record) {
								if (record === contactRecord) {
									store.un('open', fn, task);
									var recipient = contactRecord.convertToRecipient(Zarafa.core.mapi.RecipientType.MAPI_TO, true);
									recipientStore.add(recipient);
									callback();
								}
							};

							contactRecord.getStore().on('open', fn, task);
							contactRecord.open();
						}
					// This triggers the encapsulation and returns the task function
					}()
				});
			}
		}
		
		config = Ext.applyIf(config || {}, {
			recordComponentPluginConfig : {
				loadTasks : tasks
			}
		});
		
		Zarafa.core.data.UIFactory.openCreateRecord(emailRecord, config);
	},
	
	
	/**
	 * Create a new item...
	 *
	 *
	 */
	openCreateOwncloudContent : function(model, config) {
		var record = model.createRecord();
		Zarafa.core.data.UIFactory.openCreateRecord(record, config);
	},
	
	/**
	 * Open a Panel in which the {@link Zarafa.core.data.IPMRecord record}
	 * can be viewed, or further edited.
	 *
	 * @param {Zarafa.core.data.IPMRecord} records The records to open
	 * @param {Object} config (optional) Configuration object used to create
	 * the Content Panel.
	 */
	openOwncloudContent : function(records, config) {
		var navpanel = Zarafa.plugins.owncloud.data.ComponentBox.getNavigatorTreePanel();
		var store = Zarafa.plugins.owncloud.data.ComponentBox.getStore();
		
		Ext.each(records, function(record) {
			if(record.get('type') == Zarafa.plugins.owncloud.data.FileTypes.FOLDER) {
				store.loadPath(record.get('id'));
				navpanel.getNodeById(record.get('id')).reload();
			} else
				this.downloadItem([record]);
		},this);
	},
	
	/**
	 * Refreshes the left navigator tree
	 *
	 */
	refreshNavigatorTree : function() {
		var navpanel = Zarafa.plugins.owncloud.data.ComponentBox.getNavigatorTreePanel();
		var store = Zarafa.plugins.owncloud.data.ComponentBox.getStore();
		
		// reload the navigation tree
		navpanel.getNodeById(store.getPath()).reload();
	},
	
	/**
	 * Create the upload form
	 *
	 * @param {Object} config
	 */
	createUploadDialog : function(model, config, path) {
		if(path == undefined)
			path = model.getStore().getPath();
	
		config = Ext.applyIf(config || {}, {
			modal : true,
			parentID: path
		});
		
		var componentType = Zarafa.core.data.SharedComponentType['zarafa.plugins.owncloud.uploadpanel'];
		Zarafa.core.data.UIFactory.openLayerComponent(componentType, undefined, config);
	},

	/**
	 * Create a new Folder in {@link Zarafa.core.data.IPMRecord node}
	 *
	 * @param {Zarafa.core.data.IPMRecord} node The parent folder node
	 */
	createFolder : function(model, config, path) {
		if(path == undefined)
			path = model.getStore().getPath();

		Zarafa.common.dialogs.MessageBox.prompt(dgettext('plugin_owncloud', 'Folder name'), dgettext('plugin_owncloud', 'Please enter a foldername'), function(button, text) {
			if(button == "ok") {
				try {
					// check if foldername contains a / - if so, dont rename it
					if(text.indexOf("/") !== -1 || text === "") {
						Zarafa.common.dialogs.MessageBox.show({
							title   : dgettext('plugin_owncloud', 'Warning'),
							msg     : dgettext('plugin_owncloud', 'Incorrect foldername'),
							icon    : Zarafa.common.dialogs.MessageBox.WARNING,
							buttons : Zarafa.common.dialogs.MessageBox.OK
						});
					} else {
						var d = new Date();
						var nowUTC = d.getTime() + d.getTimezoneOffset()*60*1000;
						var data = {
							"filename" : text,
							"path" : path,
							"id" : path + text + "/", 
							"message_size" : "0",
							"lastmodified" : nowUTC,
							"type" : Zarafa.plugins.owncloud.data.FileTypes.FOLDER
						};

						var rec = Zarafa.core.data.RecordFactory.createRecordObjectByCustomType(Zarafa.core.data.RecordCustomObjectType.ZARAFA_OWNCLOUD, data);

						model.getStore().add(rec);
						model.getStore().on("update", this.refreshNavigatorTree, this);
						model.getStore().commitChanges();
					}
				} catch (e) {
					Zarafa.common.dialogs.MessageBox.show({
						title   : dgettext('plugin_owncloud', 'Warning'),
						msg     : e.getMessage(),
						icon    : Zarafa.common.dialogs.MessageBox.WARNING,
						buttons : Zarafa.common.dialogs.MessageBox.OK
					});
				}
			}
		}, this);
	},
	
	/**
	 * Move specified records to the new folder
	 * 
	 * @param records array of records
	 * @param destination record or id
	 * @param overwrite boolean flag - if true, existing dst records will be overwritten, default: true
	 */
	moveRecords : function(records, destination, overwrite) {
		overwrite = typeof overwrite !== 'undefined' ? overwrite : false;
		
		var ids = [];
		Ext.each(records, function(record) {
			ids.push(record.get('id'));
		});
		
		container.getNotifier().notify('info.owncloud', dgettext('plugin_owncloud', 'Moving'), dgettext('plugin_owncloud', 'Moving the selected records!'));
		
		try {
			container.getRequest().singleRequest(
				'owncloudbrowsermodule',
				'move',
				{
					ids : ids,
					overwrite : overwrite,
					destination : destination instanceof Zarafa.plugins.owncloud.data.OwncloudRecord ? destination.get('id') : destination,
					destinationIsFolder : true
				},
				new Zarafa.plugins.owncloud.data.ResponseHandler({
					successCallback : function(response) {
						Zarafa.plugins.owncloud.data.Actions.reloadCurrentDir();
					},
					failureCallback : function(response) {
						Zarafa.common.dialogs.MessageBox.show({
							title   : dgettext('plugin_owncloud', 'Error'),
							msg     : response.message,
							icon    : Zarafa.common.dialogs.MessageBox.ERROR,
							buttons : Zarafa.common.dialogs.MessageBox.OK
						});
						Zarafa.plugins.owncloud.data.Actions.reloadCurrentDir();
					}
				})
			);
		} catch (e) {
			Zarafa.common.dialogs.MessageBox.show({
				title   : dgettext('plugin_owncloud', 'Warning'),
				msg     : e.getMessage(),
				icon    : Zarafa.common.dialogs.MessageBox.WARNING,
				buttons : Zarafa.common.dialogs.MessageBox.OK
			});
			
			return false;
		}
		
		return true;
	},
	
	/**
	 * Open a rename dialog and rename the item
	 * 
	 * @param record a records
	 */
	openRenameDialog : function (model, record) {
		Zarafa.common.dialogs.MessageBox.prompt(dgettext('plugin_owncloud', 'Rename'), dgettext('plugin_owncloud', 'Please enter a new name'), function(button, text) {
			if(button == "ok") {
				try {
					var path = record.get('path') == "/" ? "" : record.get('path');
					
					// check if filename contains a / - if so, dont rename it
					if(text.indexOf("/") !== -1 || text === "") {
						Zarafa.common.dialogs.MessageBox.show({
							title   : dgettext('plugin_owncloud', 'Warning'),
							msg     : dgettext('plugin_owncloud', 'Incorrect filename'),
							icon    : Zarafa.common.dialogs.MessageBox.WARNING,
							buttons : Zarafa.common.dialogs.MessageBox.OK
						});
					} else {
						record.beginEdit();
						record.set('filename', text);
						record.set('id', path + "/"+ text);
						record.endEdit();
					}				
				} catch (e) {
					Zarafa.common.dialogs.MessageBox.show({
						title   : dgettext('plugin_owncloud', 'Warning'),
						msg     : e.getMessage(),
						icon    : Zarafa.common.dialogs.MessageBox.WARNING,
						buttons : Zarafa.common.dialogs.MessageBox.OK
					});
				}
			}
		}, this, false, record.get('filename'));
	},
	
	/**
	 * Does a full reload of both stores
	 *
	 */
	reloadCurrentDir : function () {
		Zarafa.plugins.owncloud.data.ComponentBox.getStore().reload();
		this.refreshNavigatorTree();
	},
	
	/**
	 * Clears the webdav request cache
	 * @param reaload if true, the gridstore will be reloaded, default: true
	 */
	clearCache : function(reload) {
		
		reload = typeof reload !== 'undefined' ? reload : true;
		
		try {
			container.getRequest().singleRequest(
				'owncloudmodule',
				'clearcache',
				{},
				new Zarafa.plugins.owncloud.data.ResponseHandler({
					successCallback : function(response) {
						if(reload) {
							Zarafa.plugins.owncloud.data.Actions.reloadCurrentDir();
						}
					}
				})
			);
		} catch (e) {
			Zarafa.common.dialogs.MessageBox.show({
				title   : dgettext('plugin_owncloud', 'Warning'),
				msg     : e.getMessage(),
				icon    : Zarafa.common.dialogs.MessageBox.WARNING,
				buttons : Zarafa.common.dialogs.MessageBox.OK
			});
		}
	},
	
	/**
	 * Download the selected items from owncloud
	 *
	 * @param {Array} ids An array of ids
	 */
	downloadItem : function(records) {
		container.getNotifier().notify('info.owncloud', 'Downloading', 'Download started... please wait!');
		
		Ext.each(records, function(record) {
			var downloadFrame = Ext.getBody().createChild({
				tag: 'iframe',
				cls: 'x-hidden'
			});
			
			var url = this.getDownloadLink(record, false);
			downloadFrame.dom.contentWindow.location = url;
		}, this);
	},
	
	/**
	 * Returns a download link for the client.
	 */
	getDownloadLink : function(record, inline) {
		return typeof inline !== "undefined" && inline == false ? record.getAttachmentUrl() : record.getInlineImageUrl();
	}
};
/**
 * OwncloudRecord.js zarafa owncloud plugin
 *
 * Author: Christoph Haas <christoph.h@sprinternet.at>
 * Copyright (C) 2012-2013 Christoph Haas
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

Ext.namespace('Zarafa.plugins.owncloud.data');

/**
 * @class Zarafa.plugins.owncloud.OwncloudRecordFields
 * Array of {@link Ext.data.Field field} configurations for the
 * {@link Zarafa.core.data.IPMRecord IPMRecord} object.
 * These fields will be available in all 'IPM.Owncloud' type messages.
 */
Zarafa.plugins.owncloud.data.OwncloudRecordFields = [
	{name: 'id'},
	{name: 'path'},
	{name: 'type', type: 'int', defaultValue: Zarafa.plugins.owncloud.data.FileTypes.FOLDER},
	{name: 'filename'},
	{name: 'lastmodified', type: 'int', defaultValue: null},
	{name: 'message_size', type: 'int', defaultValue: 0}
];

/**
 * @class Zarafa.core.data.IPMAttachmentRecord
 * @extends Ext.data.Record
 */
Zarafa.plugins.owncloud.data.OwncloudRecord = Ext.extend(Zarafa.core.data.IPMRecord, {
	/**
	 * Sets the current record to disabled state
	 */
	disabled : false,
	
	/**
	 * Applies all data from an {@link Zarafa.plugins.owncloud.data.OwncloudRecord OwncloudRecord}
	 * to this instance. This will update all data.
	 * 
	 * @param {Zarafa.plugins.owncloud.data.OwncloudRecord} record The record to apply to this
	 * @return {Zarafa.plugins.owncloud.data.OwncloudRecord} this
	 */
	applyData : function(record) {
		this.beginEdit();

		Ext.apply(this.data, record.data);
		Ext.apply(this.modified, record.modified);
		
		this.dirty = record.dirty;

		this.endEdit(false);

		return this;
	},

	/**
	 * Builds and returns inline image URL to download inline images,
	 * it uses {@link Zarafa.core.data.IPMRecord IPMRecord} to get store and message entryids.
	 * @return {String} URL for downloading inline images.
	 */
	getInlineImageUrl : function() {
		var link = "";

		var protocol = container.getSettingsModel().get('zarafa/v1/contexts/owncloud/use_ssl');
		var user = container.getSettingsModel().get('zarafa/v1/contexts/owncloud/username');
		var pass = container.getSettingsModel().get('zarafa/v1/contexts/owncloud/password');
		var port = container.getSettingsModel().get('zarafa/v1/contexts/owncloud/use_ssl') == true ? container.getSettingsModel().get('zarafa/v1/contexts/owncloud/port_ssl') : container.getSettingsModel().get('zarafa/v1/contexts/owncloud/port');
		var server = container.getSettingsModel().get('zarafa/v1/contexts/owncloud/server');
		var path = container.getSettingsModel().get('zarafa/v1/contexts/owncloud/owncloud_path');

		link += "plugins/owncloud/php/proxy.php?id=" + this.get('id');
		link += "&ssl=" + protocol;
		link += "&port=" + port;
		link += "&server=" + server;
		link += "&path=" + path;
		link += "&pass=" + pass;
		link += "&user=" + user;
		link += "&inline=true";

		return link;
	},

	/**
	 * Builds and returns attachment URL to download attachment,
	 * it uses {@link Zarafa.core.data.IPMRecord IPMRecord} to get store and message entryids.
	 * @return {String} URL for downloading attachment.
	 */
	getAttachmentUrl : function() {
		var link = "";

		var protocol = container.getSettingsModel().get('zarafa/v1/contexts/owncloud/use_ssl');
		var user = container.getSettingsModel().get('zarafa/v1/contexts/owncloud/username');
		var pass = container.getSettingsModel().get('zarafa/v1/contexts/owncloud/password');
		var port = container.getSettingsModel().get('zarafa/v1/contexts/owncloud/use_ssl') == true ? container.getSettingsModel().get('zarafa/v1/contexts/owncloud/port_ssl') : container.getSettingsModel().get('zarafa/v1/contexts/owncloud/port');
		var server = container.getSettingsModel().get('zarafa/v1/contexts/owncloud/server');
		var path = container.getSettingsModel().get('zarafa/v1/contexts/owncloud/owncloud_path');

		var url = document.URL;
		link = url.substring(0, url.lastIndexOf('/') + 1); // we need the absolute url for jwplayer...
		
		link += "plugins/owncloud/php/proxy.php?id=" + this.get('id');
		link += "&ssl=" + protocol;
		link += "&port=" + port;
		link += "&server=" + server;
		link += "&path=" + path;
		link += "&pass=" + pass;
		link += "&user=" + user;
		link += "&inline=false";

		return link;
	},
	
	setDisabled : function (state) {
		this.disabled = state;
	},
	
	getDisabled : function () {
		return this.disabled;
	}
});

Zarafa.core.data.RecordCustomObjectType.addProperty('ZARAFA_OWNCLOUD');

Zarafa.core.data.RecordFactory.addFieldToMessageClass('IPM.Owncloud', Zarafa.plugins.owncloud.data.OwncloudRecordFields);
Zarafa.core.data.RecordFactory.setBaseClassToMessageClass('IPM.Owncloud', Zarafa.plugins.owncloud.data.OwncloudRecord);

Zarafa.core.data.RecordFactory.addFieldToCustomType(Zarafa.core.data.RecordCustomObjectType.ZARAFA_OWNCLOUD, Zarafa.plugins.owncloud.data.OwncloudRecordFields);
Zarafa.core.data.RecordFactory.setBaseClassToCustomType(Zarafa.core.data.RecordCustomObjectType.ZARAFA_OWNCLOUD, Zarafa.plugins.owncloud.data.OwncloudRecord);/**
 * OwncloudStore.js zarafa owncloud plugin
 *
 * Author: Christoph Haas <christoph.h@sprinternet.at>
 * Copyright (C) 2012-2013 Christoph Haas
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

Ext.namespace('Zarafa.plugins.owncloud.data');

/**
 * @class Zarafa.plugins.owncloud.data.OwncloudStore
 * @extends Zarafa.core.data.ListModuleStore
 * @xtype zarafa.owncloudstore
 * 
 * The OwncloudStore class provides a way to connect the 'owncloudlistmodule' in the server back-end to an 
 * Ext.grid.GridPanel object. It provides a means to retrieve owncloud listings asynchronously.
 * The store has to be initialised with a store Id, which corresponds (somewhat confusingly) to
 * a MAPI store id. The OwncloudStore object, once instantiated, will be able to retrieve and list
 * ownclouds from a single specific store only.
 * 
 * @constructor
 * @param {String} storeId a MAPI id that corresponds with a MAPI store on the server.
 */
Zarafa.plugins.owncloud.data.OwncloudStore = Ext.extend(Zarafa.core.data.ListModuleStore, {

	/**
	 * The root path which is loaded
	 * @private
	 */
	rootID : undefined,
	
	/**
	 * @constructor
	 * @param {String} storeId a MAPI id that corresponds with a MAPI store on the server.
	 */
	constructor : function() {
		this.rootID = "/";
		
		Zarafa.plugins.owncloud.data.OwncloudStore.superclass.constructor.call(this, {
			preferredMessageClass : 'IPM.Owncloud',
			autoSave: true,
			actionType : Zarafa.core.Actions['list'],
			defaultSortInfo : {
				field : 'filename',
				direction : 'asc'
			},
			baseParams : {
				id : this.rootID
			}
		});
	},
	
	loadPath : function(path) {
		this.rootID = path;
		var params = {
			id : this.rootID
		};
		this.load({params : params});
	},
	
	getPath : function() {
		return this.rootID;
	}
});
/**
 * ShowOwncloudFileContentPanel.js zarafa owncloud plugin
 *
 * Author: Christoph Haas <christoph.h@sprinternet.at>
 * Copyright (C) 2012-2013 Christoph Haas
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

Ext.namespace('Zarafa.plugins.owncloud.dialogs');

/**
 * @class Zarafa.plugins.owncloud.dialogs.ShowOwncloudFileContentPanel
 * @extends Zarafa.core.ui.ContentPanel
 * @xtype zarafa.showowncloudfilepanel
 */
Zarafa.plugins.owncloud.dialogs.ShowOwncloudFileContentPanel = Ext.extend(Zarafa.core.ui.ContentPanel, {

	/**
 	 * @constructor
	 * @param config Configuration structure
	 */
	constructor : function(config) {
		config = config || {};

		// Add in some standard configuration data.
		Ext.applyIf(config, {
			// Override from Ext.Component
			xtype : 'zarafa.showowncloudfilepanel',
			// Override from Ext.Panel
			layout : 'fit',
			title : dgettext('plugin_owncloud', 'File information'),
			items: [ this.createPanel(config) ]
		});
		
		// Call parent constructor
		Zarafa.plugins.owncloud.dialogs.ShowOwncloudFileContentPanel.superclass.constructor.call(this, config);
	},

	/**
	 * Add the main Window Panel to the content panel. This will contain
	 * a {@link Zarafa.core.ui.ContentPanelToolbar} and a {@link Zarafa.plugins.owncloud.ui.OwncloudFileInfo}.
	 * @return {Object} The configuration object for the panel.
	 * @private
	 */
	createPanel : function(config) {	
		// Create a new panel and add it.
		return {
			xtype: 'zarafa.owncloudfileinfo',
			record : config.record
		};
	}
});

Ext.reg('zarafa.showmailcontentpanel', Zarafa.plugins.owncloud.dialogs.ShowOwncloudFileContentPanel);
/**
 * OwncloudUploadContentPanel.js zarafa owncloud plugin
 *
 * Author: Christoph Haas <christoph.h@sprinternet.at>
 * Copyright (C) 2012-2013 Christoph Haas
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

Ext.namespace('Zarafa.plugins.owncloud.dialogs');

/**
 * @class Zarafa.plugins.owncloud.dialogs.OwncloudUploadContentPanel
 * @extends Zarafa.core.ui.ContentPanel
 * @xtype zarafa.ownclouduploadcontentpanel
 */
Zarafa.plugins.owncloud.dialogs.OwncloudUploadContentPanel = Ext.extend(Zarafa.core.ui.ContentPanel, {

	/**
	 * Target folder for uploaded files
	 *
	 */
	targetFolder : undefined,
	
	/**
 	 * @constructor
	 * @param config Configuration structure
	 */
	constructor : function(config) {
		config = config || {};

		// Add in some standard configuration data.
		Ext.applyIf(config, {
			// Override from Ext.Component
			xtype : 'zarafa.ownclouduploadcontentpanel',
			// Override from Ext.Panel
			layout : 'fit',
			title : dgettext('plugin_owncloud', 'Upload file'),
			items: [{
				/*tbar		: {
					xtype : 'zarafa.contentpaneltoolbar',
					height : 33
				},*/
				xtype : 'form',
				ref : 'mainuploadform',
				layout: {
					type : 'vbox',
					align : 'stretch',
					pack : 'start'
				},
				fileUpload : true,
				padding : 5,				
				items : [
					this.createFolderSelector(),
					this.createUploadField()					
				],
				buttons : this.createActionButtons()
			}]
		});
		
		// Call parent constructor
		Zarafa.plugins.owncloud.dialogs.OwncloudUploadContentPanel.superclass.constructor.call(this, config);
	},

	createUploadField : function() {
		return {
			xtype : 'panel',
			title : dgettext('plugin_owncloud', 'Select a file') + ':',
			layout : 'form',
			height : 55,
			items : [{
				xtype : 'textfield',
				inputType : 'file',
				style : {
					border: 'none!important'
				},
				autoCreate : {tag: 'input', type: 'text', size: '20', autocomplete: 'off', multiple: 'multiple' },
				name : 'attachments[]',
				hideLabel : true,
				anchor : '100%',
				ref : '../../mainuploadfield',
				disabled : true
			}]
		};
	},
	
	createFolderSelector : function() {
		return {
			xtype : 'treepanel',
			anchor : '0, 0',
			flex : 1,
			title : dgettext('plugin_owncloud', 'Select upload folder') + ':',
			root : {
				nodeType : 'async',
				text : '/',
				id : '/',
				expanded : true
			},
			autoScroll : true,
			viewConfig : {
				style :	{ overflow: 'auto', overflowX: 'hidden' }
			},
			maskDisabled : true,
			listeners : {
				click : function(n) {
					this.targetFolder = n.attributes.id;
					this.mainuploadfield.enable();
					this.mainuploadbutton.enable();
				},
				scope : this
			},
			loader : new Zarafa.plugins.owncloud.data.DirectoryLoader({loadfiles: false})
		};
	},
	
	/**
	 * Creates action button for uploading the file
	 * @return {Array}
	 * @private
	 */
	createActionButtons : function() {
		return[{
			xtype   : 'button',
			ref : '../../mainuploadbutton',
			disabled : true,
			text    : '&nbsp;&nbsp;' + dgettext('plugin_owncloud', 'Upload'),
			tooltip : {
				title   : dgettext('plugin_owncloud', 'Store selected file'),
				text    : dgettext('plugin_owncloud', 'Upload file to the selected +%+ folder').replace('+%+', container.getSettingsModel().get('zarafa/v1/plugins/owncloud/button_name'))
			},
			iconCls : 'icon_owncloud',
			handler : this.uploadFile,
			scope   : this
		},
		{
			xtype   : 'button',
			text    : dgettext('plugin_owncloud', 'Cancel'),
			tooltip : {
				title   : dgettext('plugin_owncloud', 'Cancel'),
				text    : dgettext('plugin_owncloud', 'Close this window')
			},
			handler : this.close,
			scope   : this
		}];
	},
	
	uploadFile : function () {
		var form = this.mainuploadform.getForm();
		
		if (form.isValid() && (typeof this.targetFolder !== "undefined")) {
			form.submit({
				waitMsg: dgettext('plugin_owncloud', 'Uploading files') + '...',
				url: 'plugins/owncloud/php/upload_file.php',
				params: {
					"parentID" : this.targetFolder,
					"ocuser" : container.getSettingsModel().get('zarafa/v1/contexts/owncloud/username'),
					"ocpass" : container.getSettingsModel().get('zarafa/v1/contexts/owncloud/password'),
					"ocserv" : container.getSettingsModel().get('zarafa/v1/contexts/owncloud/server'),
					"ocbase" : container.getSettingsModel().get('zarafa/v1/contexts/owncloud/owncloud_path'),
					"ocssl" : container.getSettingsModel().get('zarafa/v1/contexts/owncloud/use_ssl'),
					"port" : container.getSettingsModel().get('zarafa/v1/contexts/owncloud/port'),
					"portssl" : container.getSettingsModel().get('zarafa/v1/contexts/owncloud/port_ssl')
				},
				failure: function(file, action) {
					Zarafa.common.dialogs.MessageBox.show({
						title : dgettext('plugin_owncloud', 'Error'),
						msg : action.result.message,
						icon : Zarafa.common.dialogs.MessageBox.ERROR,
						buttons : Zarafa.common.dialogs.MessageBox.OK
					});
				},
				success: function(file, action) {
					var ocontext = container.getContextByName('owncloudcontext'); // dont use ComponentBox ... we need the oc context
					Zarafa.plugins.owncloud.data.Actions.clearCache(false);
					ocontext.model.store.loadPath(action.result.parent);
				},
				scope : this
			});
		} 

		form.on('actioncomplete', this.close, this, { delay : 5 });
		form.on('actionfailed', this.close, this, { delay : 5 });
	}
});

Ext.reg('zarafa.ownclouduploadcontentpanel', Zarafa.plugins.owncloud.dialogs.OwncloudUploadContentPanel);
/**
 * UploadButton.js zarafa owncloud plugin
 *
 * Author: Christoph Haas <christoph.h@sprinternet.at>
 * Copyright (C) 2012-2013 Christoph Haas
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

Ext.namespace('Zarafa.plugins.owncloud.ui');

/**
 * @class Zarafa.plugins.owncloud.ui.UploadButton
 * @extends Ext.SplitButton
 * @xtype zarafa.ownclouduploadbutton
 *
 * Special button which can be used for attaching items to a {@link Zarafa.core.data.IPMRecord IPMRecord}.
 * This utilizes the {@link #main.attachment.method} insertion point to allow plugins to register
 * alternative methods for attaching items to the record. These options will be shown inside the dropdown
 * list, while the default button action will be opening the Browsers File Selection dialog
 *
 * If the {@link Zarafa.core.plugins.RecordComponentUpdaterPlugin} is installed
 * in the {@link #plugins} array of this component, this component will automatically
 * load the {@link Zarafa.core.data.MAPIRecord record} into the component.
 * Otherwise the user of this component needs to call {@link #bindRecord}.
 */
Zarafa.plugins.owncloud.ui.UploadButton = Ext.extend(Ext.SplitButton, {
	/**
	 * @insert main.attachment.method
	 * Provide a new method for attaching files to a {@link Zarafa.core.data.IPMRecord IPMRecord}.
	 * This can be used by 3rd party plugins to insert a new MenuItem into the dropdown
	 * box for the {@link Zarafa.common.attachment.ui.AttachmentButton AttachmentButton}.
	 * This insertion point should return a {@link Ext.menu.Item item} instance of configuration
	 * @param {Zarafa.plugins.owncloud.ui.UploadButton} button This button
	 */
	 
	/**
	 * The {@link Zarafa.plugins.owncloud.OwncloudContextModel} which is obtained from the {@link #context}.
	 * @property
	 * @type Zarafa.mail.MailContextModel
	 */
	model : undefined,

	/**
	 * @constructor
	 * @param {Object} config Configuration object
	 */
	constructor : function(config) {
		config = config || {};
		if (!Ext.isDefined(config.model) && Ext.isDefined(config.context))
			config.model = config.context.getModel();

		Ext.applyIf(config, {
			menu : {
				items : [{
					text : dgettext('plugin_owncloud', 'Upload file'),
					iconCls : 'icon_owncloud_category',
					handler : function() { 
						Zarafa.plugins.owncloud.data.Actions.createUploadDialog(this.model);
					},
					scope: this
				},
				{
					text: dgettext('plugin_owncloud', 'Create folder'),
					iconCls : 'icon_createFolder',
					action:'folder', 
					handler: function() { 
						Zarafa.plugins.owncloud.data.Actions.createFolder(this.model); 
					}, 
					scope : this
				}]
			},
			handler : function() {
					this.showMenu();
			},
			scope : this
		});
		Zarafa.plugins.owncloud.ui.UploadButton.superclass.constructor.call(this, config);
	},

	/**
	 * Event handler for opening the Browser's file selection dialog.
	 * See {@link #onFileInputChange} for the handling of the selected files.
	 * @private
	 */
	onFileUpload : function(field, event) {
		/*if (Zarafa.supportsFilesAPI()) {
			var attachEl = this.getAttachmentEl();

			// Register the change event handler
			// so we detect when the user selects a file.
			attachEl.on('change', this.onFileInputChange, this);

			// Mimick clicking on the <input> field
			// to open the File Selection dialog.
			attachEl.dom.click();
		} else {*/
			// With legacy upload we need a valid form, and we cannot
			// mimick clicking on the <input> field. Hence a secondary
			// dialog which should handle that.
			Zarafa.plugins.owncloud.data.Actions.createUploadDialog({
				parentID : "myroot",
				scope : this
			});
		//}
	}	
});

Ext.reg('zarafa.ownclouduploadbutton', Zarafa.plugins.owncloud.ui.UploadButton);
/**
 * UploadPanel.js zarafa owncloud plugin
 *
 * Author: Christoph Haas <christoph.h@sprinternet.at>
 * Copyright (C) 2012-2013 Christoph Haas
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

Ext.namespace('Zarafa.plugins.owncloud.ui');

/**
 * @class Zarafa.plugins.owncloud.ui.UploadPanel
 * @extends Zarafa.core.ui.ContentPanel
 * @xtype zarafa.plugins.owncloud.uploadpanel
 */
Zarafa.plugins.owncloud.ui.UploadPanel = Ext.extend(Zarafa.core.ui.ContentPanel, {
	/**
	 * @cfg {Function} callback The callback function which must be called when the
	 * {@link Ext.ux.form.FileUploadField File Input field} has been changed. It will
	 * receive the {@link Ext.form.BasicForm BasicForm} in which the input field is located
	 * as argument.
	 */
	callback : Ext.emptyFn,

	/**
	 * @cfg {Object} scope The scope for the {@link #callback} function
	 */
	scope : undefined,
	
	/**
	 * @cfg {String} parentID
	 */
	parentID : "/",
	
	/**
	 * @constructor
	 * @param {Object} config Configuration object
	 */
	constructor : function(config) {
		config = config || {};

		Ext.applyIf(config, {
			title : dgettext('plugin_owncloud', 'Select file'),
			layout : 'fit',
			width : 500,
			height : 75,
			items : [{
				xtype : 'form',
				layout: 'fit',
				fileUpload : true,
				ref : 'owncloudUploadform',
				padding : 5,
				items : [{
					xtype : 'textfield',
					inputType : 'file',
					style : {
						border: 'none!important'
					},
					autoCreate : {tag: 'input', type: 'text', size: '20', autocomplete: 'off', multiple: 'multiple' },
					name : 'attachments[]'
				}],
				buttons : [{
					text : dgettext('plugin_owncloud', 'Upload'),
					iconCls : 'icon_owncloud',
					handler : this.onUpload,
					scope : this
				},
				{
					text : dgettext('plugin_owncloud', 'Cancel'),
					handler : this.close,
					scope : this
				}]
			}]
		});

		Zarafa.plugins.owncloud.ui.UploadPanel.superclass.constructor.call(this, config);
	},

	/**
	 * Event which is fired when the {@link Ext.ux.form.FileUploadField#fileselected fileselected} was fired.
	 * This will invoke the {@link #callback} function.
	 */
	onUpload : function() {
		var form = this.owncloudUploadform.getForm();

		// Immediately hide the dialog, we will close
		// it (destroying the HTML elements) once the
		// upload has completed.
		this.hide();
		
		if (form.isValid()) {
			form.submit({
				waitMsg: dgettext('plugin_owncloud', 'Uploading files') + '...',
				url: 'plugins/owncloud/php/upload_file.php',
				params: {
					"parentID" : this.parentID,
					"ocuser" : container.getSettingsModel().get('zarafa/v1/contexts/owncloud/username'),
					"ocpass" : container.getSettingsModel().get('zarafa/v1/contexts/owncloud/password'),
					"ocserv" : container.getSettingsModel().get('zarafa/v1/contexts/owncloud/server'),
					"ocbase" : container.getSettingsModel().get('zarafa/v1/contexts/owncloud/owncloud_path'),
					"ocssl" : container.getSettingsModel().get('zarafa/v1/contexts/owncloud/use_ssl'),
					"port" : container.getSettingsModel().get('zarafa/v1/contexts/owncloud/port'),
					"portssl" : container.getSettingsModel().get('zarafa/v1/contexts/owncloud/port_ssl')
				},
				failure: function(file, action) {
					Zarafa.common.dialogs.MessageBox.show({
						title : dgettext('plugin_owncloud', 'Error'),
						msg : action.result.message,
						icon : Zarafa.common.dialogs.MessageBox.ERROR,
						buttons : Zarafa.common.dialogs.MessageBox.OK
					});
				},
				success: function(file, action) {
					Zarafa.plugins.owncloud.data.Actions.clearCache(false);
					Zarafa.plugins.owncloud.data.ComponentBox.getStore().loadPath(action.result.parent);
				},
				scope : this
			});
		}

		form.on('actioncomplete', this.close, this, { delay : 5 });
		form.on('actionfailed', this.close, this, { delay : 5 });
	}
});

Ext.reg('zarafa.plugins.owncloud.uploadpanel', Zarafa.plugins.owncloud.ui.UploadPanel);
/**
 * NavigatorTreePanel.js zarafa owncloud plugin
 *
 * Author: Christoph Haas <christoph.h@sprinternet.at>
 * Copyright (C) 2012-2013 Christoph Haas
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

Ext.namespace('Zarafa.plugins.owncloud.ui');

/**
 * @class Zarafa.plugins.owncloud.ui.NavigatorTreePanel
 * @extends Ext.tree.TreePanel
 * Shows tree of all user files from Owncloud
 */
Zarafa.plugins.owncloud.ui.NavigatorTreePanel = Ext.extend(Ext.tree.TreePanel, {

	/**
	 * @constructor
	 * @param {Object} config
	 */
	constructor : function(config) {
		config = config || {};
		Ext.applyIf(config, {
			xtype : 'zarafa.owncloudtreepanel',
			enableDD : true,
			ddGroup : 'dd.owncloudrecord',
			root: {
				nodeType: 'async',
				text: '/',
				id: '/',
				expanded : true
			},
			autoScroll: true,
			listeners: {
				click: function(n) {
					Zarafa.plugins.owncloud.data.ComponentBox.getStore().loadPath(n.attributes.id);
					this.getNodeById(n.attributes.id).reload();
				},
				beforenodedrop: {fn: function(e) {
				
					// e.data.selections is the array of selected records
					if(Ext.isArray(e.data.selections)) {
						// reset cancel flag
						e.cancel = false;
						
						Ext.each(e.data.selections, function(record) {
							record.setDisabled(true);
						});
						
						// we want Ext to complete the drop, thus return true
						return Zarafa.plugins.owncloud.data.Actions.moveRecords(e.data.selections,e.target.id);
					}
					// if we get here the drop is automatically cancelled by Ext
				}},
				afterrender : function() {
					this.dragZone.lock(); // disable dragging from treepanel
				},
				scope: this
			},
			viewConfig: {
				style : { overflow: 'auto', overflowX: 'hidden' }
			},
			maskDisabled: true,
			loader : new Zarafa.plugins.owncloud.data.DirectoryLoader({loadfiles: false})
		});
		Zarafa.plugins.owncloud.ui.NavigatorTreePanel.superclass.constructor.call(this, config);
	}
});

Ext.reg('zarafa.owncloudtreepanel',Zarafa.plugins.owncloud.ui.NavigatorTreePanel); 
/**
 * OwncloudViewPanel.js zarafa owncloud plugin
 *
 * Author: Christoph Haas <christoph.h@sprinternet.at>
 * Copyright (C) 2012-2013 Christoph Haas
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

Ext.namespace('Zarafa.plugins.owncloud.ui');

/**
 * @class Zarafa.plugins.owncloud.ui.OwncloudViewPanel
 * @extends Ext.Panel
 * @xtype zarafa.owncloudviewpanel
 * 
 * Panel that shows the contents of mail messages.
 */
Zarafa.plugins.owncloud.ui.OwncloudViewPanel = Ext.extend(Ext.Panel, {
	/**
	 * @constructor
	 * @param {Object} config configuration object.
	 */
	constructor : function(config) {
		config = config || {};
		
		Ext.applyIf(config, {
			xtype: 'zarafa.owncloudviewpanel',
			border : false,
			cls: 'zarafa-owncloudviewpanel',
			layout: 'zarafa.collapsible',
			items : [{
				xtype: 'zarafa.owncloudfileinfo'
			}]
		});

		Zarafa.plugins.owncloud.ui.OwncloudViewPanel.superclass.constructor.call(this, config);
	}
});

Ext.reg('zarafa.owncloudviewpanel', Zarafa.plugins.owncloud.ui.OwncloudViewPanel);
/**
 * OwncloudFileInfo.js zarafa owncloud plugin
 *
 * Author: Christoph Haas <christoph.h@sprinternet.at>
 * Copyright (C) 2012-2013 Christoph Haas
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

Ext.namespace('Zarafa.plugins.owncloud.ui');

/**
 * @class Zarafa.plugins.owncloud.ui.OwncloudFileInfo
 * @extends Ext.Panel
 * @xtype zarafa.owncloudfileinfo
 */
Zarafa.plugins.owncloud.ui.OwncloudFileInfo = Ext.extend(Ext.form.FormPanel, {

	/**
	 * The default preview image url
	 */
	defaultPreviewImage : 'plugins/owncloud/resources/images/no-preview.jpg',
	
	/**
	 * The record that will be shown
	 * only used in the dialog
	 */
	record : undefined,
	
	/**
	 * @constructor
	 * @param {Object} config configuration object.
	 */
	constructor : function(config) {
		config = config || {};
		var context = Zarafa.plugins.owncloud.data.ComponentBox.getContext();
		var viewMode = context.getCurrentViewMode();		
		
		var layout = {
			type : 'vbox',
			align : 'stretch',
			pack : 'start'
		};
		switch(viewMode) {
			case Zarafa.plugins.owncloud.data.ViewModes.RIGHT_PREVIEW:
				break;
			case Zarafa.plugins.owncloud.data.ViewModes.BOTTOM_PREVIEW:
				layout = {
					type : 'hbox',
					align : 'stretch',
					pack : 'start'
				};
				break;
			default:
				break;
		}

		config = Ext.applyIf(config, {
			xtype : 'zarafa.owncloudfileinfo',
			ref : '../fileinfo',
			autoDestroy : true,
			layout : layout,
			border : false,
			items: [
				this.fieldSetFileInfo(),
				this.fieldSetFilePreview()
			]
		});
		
		if(typeof config.record !== "undefined") {
			this.record = config.record;
			config = Ext.applyIf(config, {
				listeners : {
					afterlayout : function (cmp) {
						this.update(this.record);
					}
				}
			});
		}

		Zarafa.plugins.owncloud.ui.OwncloudFileInfo.superclass.constructor.call(this, config);
	},
	
	/**
	 * clear the whole ui and redraw it
	 * 
	 */
	refresh : function() {
		this.removeAll();
		this.add(this.fieldSetFileInfo());
		this.add(this.fieldSetFilePreview());
	},
	
	/**
	 * The fieldset for the file infos
	 */
	fieldSetFileInfo: function() {
		return {
			xtype : 'fieldset',
			title : dgettext('plugin_owncloud', 'File information'),
			height : 150,
			width : 300,
			defaults: {
				anchor: '-3' // leave a litte space
			},
			items : [{
				xtype : 'textfield',
				fieldLabel : dgettext('plugin_owncloud', 'Filename'),
				ref : '../filename',
				value : "unknown",
				readOnly: true
			},
			{
				xtype : 'textfield',
				fieldLabel : dgettext('plugin_owncloud', 'Filesize'),
				ref : '../filesize',
				value : "unknown",
				readOnly: true
			},
			{
				xtype : 'textfield',
				fieldLabel : dgettext('plugin_owncloud', 'Last modified'),
				ref : '../lastmodified',
				value : "unknown",
				readOnly : true
			},
			{
				xtype : 'textfield',
				fieldLabel : dgettext('plugin_owncloud', 'Type'),
				ref : '../type',
				value : "unknown",
				readOnly : true
			}]
		};
	},
	
	/**
	 * The fieldset for the file preview
	 */
	fieldSetFilePreview : function() {
		var context = Zarafa.plugins.owncloud.data.ComponentBox.getContext();
		var viewMode = context.getCurrentViewMode();
		
		var css = "width: 100%;";
		switch(viewMode) {
			case Zarafa.plugins.owncloud.data.ViewModes.RIGHT_PREVIEW:
				css = "width: 100%;";
				break;
			case Zarafa.plugins.owncloud.data.ViewModes.BOTTOM_PREVIEW:
				css = "height: 100%;";
				break;
			default:
				break;
		}
		
		return {
			xtype : 'fieldset',
			title : dgettext('plugin_owncloud', 'File preview'),
			ref : 'filepreview',
			flex : 1,
			//defaults : {anchor: '0, 0'},
			defaultType : 'textfield',
			items : [{
				xtype : 'component',
				id : 'previewimage',
				autoEl : { tag: 'img', src: this.defaultPreviewImage, style: css}
			}]
		};
	},
	
	setPreviewPanel : function (record, extension) {
		var context = Zarafa.plugins.owncloud.data.ComponentBox.getContext();
		var viewMode = context.getCurrentViewMode();
		var mediaEnabled = Ext.ComponentMgr.isRegistered('mediapanel');
		
		var css = "width: 100%;";
		switch(viewMode) {
			case Zarafa.plugins.owncloud.data.ViewModes.RIGHT_PREVIEW:
				css = "width: 100%;";
				break;
			case Zarafa.plugins.owncloud.data.ViewModes.BOTTOM_PREVIEW:
				css = "height: 100%;";
				break;
			default:
				break;
		}
		
		var component = {};
		
		// check extension and decide which preview to show
		if(extension != '' && (/\.(gif|jpg|jpeg|tiff|png)$/i).test(extension)) {
			component = {
				xtype : 'component',
				autoEl : { tag: 'img', src: Zarafa.plugins.owncloud.data.Actions.getDownloadLink(record), style: css}
			}
		} else if (mediaEnabled && extension != '' && (/\.(pdf)$/i).test(extension)) {
			component = {
				xtype : 'mediapanel',
				anchor: '0, 0',
				mediaCfg : {
					mediaType : 'PDF',
					url : Zarafa.plugins.owncloud.data.Actions.getDownloadLink(record),
					unsupportedText : dgettext('plugin_owncloud', 'Sorry - no preview for this PDF file!')
				}
			}
		} else if (extension != '' && (/\.(txt|html|php|js|c|cpp|java|sh|bat|log|cfg|conf)$/i).test(extension)) {
			component = {
				xtype: 'textarea',
				hideLabel : true,
				readOnly : true,
				anchor: '0, 0',
				listeners : {
					'afterrender' : function () {
						Ext.Ajax.request({
							method : 'GET',
							url : Zarafa.plugins.owncloud.data.Actions.getDownloadLink(record),
							success: function( result, request ){
								var responsetext = result.responseText;
								
								// beautify the text...
								// only if we use a htmleditor
								
								/*responsetext = responsetext.replace(/\n\r?/g, '<br />');
								responsetext = responsetext.replace(/\t/g, '&nbsp;&nbsp;&nbsp;&nbsp;');
								responsetext = responsetext.replace(/ /g,"&nbsp;");*/
								this.setRawValue(responsetext);
							},
							scope : this
						});
					}
				}
			}
		} else if (mediaEnabled && extension != '' && (/\.(mp3|aac|ogg)$/i).test(extension)) {
			component = {
				xtype : 'mediapanel', // could be replaced by Ext.FlashComponent
				anchor: '0, 0',
				mediaCfg : {
					mediaType : 'JWP',
					url : 'plugins/owncloud/resources/flash/player.swf',
					width : '100%',
					height: 100,
					start : false,
					loop : false,
					unsupportedText : dgettext('plugin_owncloud', 'JW FLV Player is not installed/available.'),
					params : {
						wmode : 'transparent',
						allowscriptaccess : 'always',
						allowfullscreen : 'false', // fullscreen wont work in flash
						flashVars : {
							width      : '@width',
							height     : '@height',
							autostart  : '@start',
							file       : Zarafa.plugins.owncloud.data.Actions.getDownloadLink(record,false),
							skin       : 'plugins/owncloud/resources/flash/jwskin/lightrv5/lightrv5.xml',
							type	   : 'sound',
							showdigits : true,
							volume     : 15,
							repeat     : '@loop'
						}
					}
				}
			}
		} else if (mediaEnabled && extension != '' && (/\.(mp4|flv|mov|webm)$/i).test(extension)) {
			component = {
				xtype : 'mediapanel', // could be replaced by Ext.FlashComponent
				anchor: '0, 0',
				mediaCfg : {
					mediaType : 'JWP',
					url : 'plugins/owncloud/resources/flash/player.swf',
					width : '100%',
					start : false,
					loop : false,
					unsupportedText : dgettext('plugin_owncloud', 'JW FLV Player is not installed/available.'),
					params : {
						wmode : 'transparent',
						allowscriptaccess : 'always',
						allowfullscreen : 'false', // fullscreen wont work in flash
						flashVars : {
							width      : '@width',
							height     : '@height',
							autostart  : '@start',
							file       : Zarafa.plugins.owncloud.data.Actions.getDownloadLink(record,false),
							skin       : 'plugins/owncloud/resources/flash/jwskin/lightrv5/lightrv5.xml',
							type	   : 'video',
							showdigits : true,
							volume     : 15,
							repeat     : '@loop'
						}
					}
				}
			}
		} else {
			component = {
				xtype : 'component',
				autoEl : { tag: 'img', src: this.defaultPreviewImage, style: css}
			}
		}
		
		this.filepreview.removeAll(true);
		this.filepreview.add(component);
		this.filepreview.doLayout();    
	},
	
	/**
	 * Updates the container by loading data from the record data into the {@link #template}
	 * 	
	 * @param {Zarafa.core.data.IPMRecord} record The record to update the header panel with
	*/	
	update : function(record) {	
		//TODO: change layout of parent container!		
		var extension = this.getExtension(record.get('filename'));
		
		this.filename.setValue(record.get('filename'));
		this.filesize.setValue(Zarafa.plugins.owncloud.data.Helper.Format.fileSize(record.get('message_size')));
		this.lastmodified.setValue(Ext.util.Format.date(new Date(record.get('lastmodified'))));
		this.type.setValue(record.get('type') == 1 ? dgettext('plugin_owncloud', 'File (+%+)').replace('+%+', extension) : dgettext('plugin_owncloud', 'Folder'));
		
		this.setPreviewPanel(record, extension);
	},

	/**
	 * Called when this component is being rendered into a container.
	 * This will create a {@link #wrap} element around the iframe for
	 * better organize the scrolling.
	 *
	 * @param {Ext.Container} ct The container into which this component is being rendered
	 * @param {Number} position The position inside the container where this component is being rendered
	 * @private
	 */
	onRender : function(ct, position) {
		Zarafa.plugins.owncloud.ui.OwncloudFileInfo.superclass.onRender.call(this, ct, position);
		this.wrap = this.el.wrap({cls: 'preview-body'});
		this.resizeEl = this.positionEl = this.wrap;
	},
	
	/**
	 * Get the extension from the filename
	 *
	 * @param {String} Filename
	 * @return {String} Extension string
	 */
	getExtension : function(filename) {
		var i = filename.lastIndexOf('.');
		return (i < 0) ? '' : filename.substr(i);
	}
});

Ext.reg('zarafa.owncloudfileinfo', Zarafa.plugins.owncloud.ui.OwncloudFileInfo);
/**
 * OwncloudPreviewPanelToolbarButtons.js zarafa owncloud plugin
 *
 * Author: Christoph Haas <christoph.h@sprinternet.at>
 * Copyright (C) 2012-2013 Christoph Haas
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

Ext.namespace('Zarafa.plugins.owncloud.ui');

/**
 * @class Zarafa.plugins.owncloud.ui.OwncloudPreviewPanelToolbarButtons
 * @extends Object
 *
 * Contains special toolbar buttons for the previewpanel of the owncloud context.
 */
Zarafa.plugins.owncloud.ui.OwncloudPreviewPanelToolbarButtons = Ext.extend(Object, {
	/**
	 * @cfg {@link Zarafa.plugins.owncloud.context.OwncloudContextModel}
	 */
	model : undefined,

	/**
	 * @constructor
	 * @param config Configuration structure
	 */
	constructor : function(config) {
		Ext.apply(this, config);
	},

	/**
	 * Function called when insertion point previewpanel.toolbar.right is called,
	 * Function returns configuration object for Copy/Move, Delete and Print buttons
	 * which are added on the right side of previewpanels toolbar.
	 * 
	 * @return {Object} Configuration object containing buttons
	 * which are added in the {@link Ext.Toolbar Toolbar}.
	 */
	getToolbarButtons : function() {
		return [{
			xtype: 'tbfill'
		},
		{
			xtype: 'zarafa.toolbarbutton',
			tooltip: dgettext('plugin_owncloud', 'Delete'),
			overflowText: dgettext('plugin_owncloud', 'Delete'),
			iconCls : 'icon_delete',
			nonEmptySelectOnly: true,
			handler: this.onDelete,
			model: this.model
		},
		{
			xtype: 'zarafa.toolbarbutton',
			tooltip: dgettext('plugin_owncloud', 'Rename'),
			overflowText: dgettext('plugin_owncloud', 'Rename'),
			iconCls : 'icon_rename',
			nonEmptySelectOnly: true,
			handler: this.onRename,
			model: this.model
		}];
	},
	
	/**
	 * Rename the item
	 * @private
	 */
	onRename : function() {
		var records = this.model.getSelectedRecords();
		
		if(records.length != 1) {
			Zarafa.common.dialogs.MessageBox.show({
				title   : dgettext('plugin_owncloud', 'Warning'),
				msg     : dgettext('plugin_owncloud', 'You can only rename one file!'),
				icon    : Zarafa.common.dialogs.MessageBox.WARNING,
				buttons : Zarafa.common.dialogs.MessageBox.OK
			});
		} else {
			Zarafa.plugins.owncloud.data.Actions.openRenameDialog(this.model, records[0]);
		}
	},
	
	/**
	 * Delete the item
	 * @private
	 */
	onDelete : function() {
		var allowDelete = true;
		var records = this.model.getSelectedRecords();
		
		if(records.length != 1) {
			Zarafa.common.dialogs.MessageBox.show({
				title   : dgettext('plugin_owncloud', 'Warning'),
				msg     : dgettext('plugin_owncloud', 'You can only delete one file!'),
				icon    : Zarafa.common.dialogs.MessageBox.WARNING,
				buttons : Zarafa.common.dialogs.MessageBox.OK
			});
		} else {
			Ext.each(records, function(record) {
				if(record.get('id') == (container.getSettingsModel().get('zarafa/v1/contexts/owncloud/owncloud_path') + "/") || record.get('filename') == "..") {
					allowDelete = false;
				}
			}, this);
			
			var askOnDelete = container.getSettingsModel().get('zarafa/v1/contexts/owncloud/ask_before_delete');
			
			if(allowDelete) {
				if(askOnDelete) {
					Ext.MessageBox.confirm(dgettext('plugin_owncloud', 'Confirm deletion'), dgettext('plugin_owncloud', 'Are you sure?'), function showResult(btn) {
						if(btn == 'yes') {
							Zarafa.common.Actions.deleteRecords(records);
							Zarafa.plugins.owncloud.data.Actions.refreshNavigatorTree();
						}
					}, this);
				} else {
					Zarafa.common.Actions.deleteRecords(records);
					Zarafa.plugins.owncloud.data.Actions.refreshNavigatorTree();
				}
			}
		}
	}
});
/**
 * OwncloudToolbar.js zarafa owncloud plugin
 *
 * Author: Christoph Haas <christoph.h@sprinternet.at>
 * Copyright (C) 2012-2013 Christoph Haas
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

Ext.namespace('Zarafa.plugins.owncloud.ui');

/**
 * @class Zarafa.plugins.owncloud.ui.OwncloudToolbar
 * @extends Ext.Toolbar
 * The toolbar shown in the owncloud context
 */
Zarafa.plugins.owncloud.ui.OwncloudToolbar = Ext.extend(Ext.Toolbar, {

	/**
	 * @constructor
	 * @param {Object} config
	 */
	constructor : function(config) {
		config = config || {};
		
		config.plugins = Ext.value(config.plugins, []);
		config.plugins.push('zarafa.recordcomponentupdaterplugin');

		Ext.applyIf(config, {
			items: [{
				xtype : 'zarafa.ownclouduploadbutton',
				ref : 'uploadbutton',
				plugins : [ 'zarafa.recordcomponentupdaterplugin' ],
				model : config.context.getModel(),
				overflowText : dgettext('plugin_owncloud', 'Create something new') + '...',
				tooltip : {
					title : dgettext('plugin_owncloud', 'New'),
					text : dgettext('plugin_owncloud', 'Upload file / Create folder')
				},
				iconCls : 'icon_attachment'
			},
			{
				xtype: 'tbfill'
			},
			{
				xtype: 'zarafa.toolbarbutton',
				tooltip: dgettext('plugin_owncloud', 'Clear cache'),
				overflowText: dgettext('plugin_owncloud', 'Clear cache'),
				iconCls: 'icon_cache',
				hidden: !container.getSettingsModel().get('zarafa/v1/contexts/owncloud/enable_caching'),
				handler: this.onClearCache,
				model: config.context.getModel()
			},
			container.populateInsertionPoint('context.owncloudcontext.toolbar.item', this),
			{
				xtype: 'tbseparator'
			},
			{
				xtype: 'tbtext', 
				text: 'Version: ' + Zarafa.plugins.owncloud.data.Version.getOwncloudVersion()
			}]
		});
		Zarafa.plugins.owncloud.ui.OwncloudToolbar.superclass.constructor.call(this, config);
	},
	
	/**
	 * Clear the webdav request cache!
	 * @private
	 */
	onClearCache : function() {
		Zarafa.plugins.owncloud.data.Actions.clearCache();
	}
});

Ext.reg('zarafa.owncloudtoolbar',Zarafa.plugins.owncloud.ui.OwncloudToolbar);/**
 * OwncloudPreviewPanel.js zarafa owncloud plugin
 *
 * Author: Christoph Haas <christoph.h@sprinternet.at>
 * Copyright (C) 2012-2013 Christoph Haas
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

Ext.namespace('Zarafa.plugins.owncloud.ui');

/**
 * @class Zarafa.plugins.owncloud.ui.OwncloudPreviewPanel
 * @extends Zarafa.core.ui.PreviewPanel
 * @xtype zarafa.owncloudpreviewpanel
 */
Zarafa.plugins.owncloud.ui.OwncloudPreviewPanel = Ext.extend(Ext.Panel, {
	/**
	 * @constructor
	 * @param config Configuration structure
	 */
	constructor : function(config) {
		config = config || {};

		if (!Ext.isDefined(config.model) && Ext.isDefined(config.context))
			config.model = config.context.getModel();
		
		var toolbarButtons = new Zarafa.plugins.owncloud.ui.OwncloudPreviewPanelToolbarButtons({model: config.model});
		var tbarItems = [
			container.populateInsertionPoint('owncloudpreviewpanel.toolbar.left', this, config.model),
			{xtype: 'tbfill'},
			toolbarButtons.getToolbarButtons(), // Default items in toolbar should be right aligned.
			container.populateInsertionPoint('owncloudpreviewpanel.toolbar.right', this, config.model)
		]
		
		var toolbar = Ext.applyIf(config.tbar || {}, {
			cls: 'zarafa-previewpanel-toolbar',
			xtype : 'zarafa.toolbar',
			height : 33,
			hidden : false,
			items : Ext.flatten(tbarItems)
		});
		
		Ext.applyIf(config, {
			xtype : 'zarafa.owncloudpreviewpanel',
			layout : 'fit',
			stateful : true,
			cls : 'zarafa-previewpanel zarafa-context-mainpanel',
			width : 300, // default values
			height : 300, // default values
			tbar : toolbar			
		});

		Zarafa.plugins.owncloud.ui.OwncloudPreviewPanel.superclass.constructor.call(this, config);
	}
});

Ext.reg('zarafa.owncloudpreviewpanel', Zarafa.plugins.owncloud.ui.OwncloudPreviewPanel);

/**
 * OwncloudFileGridColumnModel.js zarafa owncloud plugin
 *
 * Author: Christoph Haas <christoph.h@sprinternet.at>
 * Copyright (C) 2012-2013 Christoph Haas
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

Ext.namespace('Zarafa.plugins.owncloud.ui');

/**
 * @class Zarafa.plugins.owncloud.ui.OwncloudFileGridColumnModel
 * @extends Zarafa.common.ui.grid.ColumnModel
 *
 * The {@link Zarafa.plugins.owncloud.ui.OwncloudFileGridColumnModel OwncloudFileGridColumnModel}
 * is the default {@link Ext.grid.ColumnModel ColumnModel} containing two
 * different sets of {@link Ext.grid.Column columns}. The first set contains
 * all {@link Ext.grid.Column columns} which should be available in the
 * {@link Zarafa.plugins.owncloud.ui.OwncloudFileGrid OwncloudFileGrid} (either hidden by default,
 * or directly visible). For a more compact view, a more compact set is
 * provided. Switching between the two sets can be done using
 * {@link Zarafa.plugins.owncloud.ui.OwncloudFileGridColumnModel.useCompactView useCompactView}
 * during configuration, or {@link Zarafa.plugins.owncloud.ui.OwncloudFileGridColumnModel.setCompactView setCompactView}
 * when the {@link Zarafa.plugins.owncloud.ui.OwncloudFileGridColumnModel OwncloudFileGridColumnModel} is already active.
 */
Zarafa.plugins.owncloud.ui.OwncloudFileGridColumnModel = Ext.extend(Zarafa.common.ui.grid.ColumnModel, {
	/**
	 * @cfg {Boolean} useCompactView If true the compact column model will be
	 * used by default. Otherwise the default column model will be used which
	 * contains all possible columns.
	 */
	useCompactView : false,
	
	/**
	 * @constructor
	 * @param config Configuration structure
	 */
	constructor : function(config) {
		config = config || {};

		this.defaultColumns = this.createDefaultColumns();
		this.compactColumns = this.createCompactColumns();

		Ext.applyIf(config, {
			columns: this.defaultColumns,
			defaults: {
				sortable: true
			}
		});

		// Switch to compact view if needed
		if (config.useCompactView === true)
			config.columns = this.compactColumns;

		Ext.apply(this, config);

		Zarafa.plugins.owncloud.ui.OwncloudFileGridColumnModel.superclass.constructor.call(this, config);
	},

	/**
	 * Create an array of {@link Ext.grid.Column columns} which must be visible within
	 * the default view of this {@link Ext.grid.ColumnModel ColumnModel}.
	 *
	 * @return {Ext.grid.Column|Array} The array of columns
	 * @private
	 */
	createDefaultColumns : function() {
		return [{
			id : 'type',
			dataIndex : 'type',
			header : '<p class="icon_index">&nbsp;</p>',
			renderer : Zarafa.plugins.owncloud.data.Helper.Renderer.typeRenderer,
			width: 24,
			fixed : true,
			tooltip : dgettext('plugin_owncloud', 'Sort by: Type')
		},
		{
			header : 'ID',
			dataIndex : 'id',
			width: 50,
			hidden: true,
			tooltip : dgettext('plugin_owncloud', 'Sort by: ID')
		},
		{
			header : 'Path',
			dataIndex : 'path',
			width: 100,
			hidden: true,
			tooltip : dgettext('plugin_owncloud', 'Sort by: Path')
		},
		{
			header : dgettext('plugin_owncloud', 'Filename'),
			dataIndex : 'filename',
			width : 160,
			tooltip : dgettext('plugin_owncloud', 'Sort by: Filename')
		},
		{
			header : dgettext('plugin_owncloud', 'Last modified'),
			dataIndex : 'lastmodified',
			width : 160,
			renderer : Zarafa.plugins.owncloud.data.Helper.Renderer.datetimeRenderer,
			tooltip : dgettext('plugin_owncloud', 'Sort by: Last modified')
		},
		{
			header : dgettext('plugin_owncloud', 'Size'),
			dataIndex : 'message_size',
			width : 80,
			renderer : Zarafa.plugins.owncloud.data.Helper.Format.fileSize,
			tooltip : dgettext('plugin_owncloud', 'Sort by: Size')
		}];
	},	

	/**
	 * Create an array of {@link Ext.grid.Column columns} which must be visible within
	 * the compact view of this {@link Ext.grid.ColumnModel ColumnModel}.
	 *
	 * @return {Ext.grid.Column|Array} The array of columns
	 * @private
	 */
	createCompactColumns : function() {
		return [{
			id : 'column_type',
			dataIndex : 'type',
			header : '<p class="icon_index">&nbsp;</p>',
			renderer : Zarafa.plugins.owncloud.data.Helper.Renderer.typeRenderer,
			width: 24,
			fixed : true,
			tooltip : dgettext('plugin_owncloud', 'Sort by: Type')
		},
		{
			header : dgettext('plugin_owncloud', 'Filename'),
			dataIndex : 'filename',
			width : 160,
			tooltip : dgettext('plugin_owncloud', 'Sort by: Filename')
		},
		{
			header : dgettext('plugin_owncloud', 'Last modified'),
			dataIndex : 'lastmodified',
			width : 100,
			renderer : Zarafa.plugins.owncloud.data.Helper.Renderer.datetimeRenderer,
			tooltip : dgettext('plugin_owncloud', 'Sort by: Last modified')
		}];
	},

	/**
	 * This will switch the {@link Zarafa.plugins.owncloud.ui.OwncloudFileGridColumnModel columnmodel}
	 * configuration to either the compact or extended configuration.
	 *
	 * @param {Boolean} compact True to enable the compact view
	 */
	setCompactView : function(compact) {
		if (this.useCompactView !== compact) {
			this.useCompactView = compact;

			if (compact) {
				this.name = 'compact';
				// Extjs will store the this.columns into this.config after it has constructed
				// all the columns. At that point this.columns consists of the configuration objects,
				// while this.columns consists of all the allocated columns.
				this.defaultColumns = this.config;
				this.columns = this.compactColumns;
			} else {
				this.name = 'default';
				this.compactColumns = this.config;
				this.columns = this.defaultColumns;
			}

			this.setConfig(this.columns, false);
		}
	}
});
/**
 * OwncloudFileGridContextMenu.js zarafa owncloud plugin
 *
 * Author: Christoph Haas <christoph.h@sprinternet.at>
 * Copyright (C) 2012-2013 Christoph Haas
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

Ext.namespace('Zarafa.plugins.owncloud.ui');

/**
 * @class Zarafa.plugins.owncloud.ui.OwncloudFileGridContextMenu
 * @extends Zarafa.core.ui.menu.ConditionalMenu
 * @xtype zarafa.owncloudfilegridcontextmenu
 *
 * Extend {@link Zarafa.core.ui.menu.ConditionalMenu ConditionalMenu} to add the
 * {@link Zarafa.core.ui.menu.ConditionalItems ConditionalItems} for the
 * OwncloudContext.
 */
Zarafa.plugins.owncloud.ui.OwncloudFileGridContextMenu = Ext.extend(Zarafa.core.ui.menu.ConditionalMenu, {
	// Insertion points for this class
	/**
	 * @insert context.owncloud.contextmenu.actions
	 * Insertion point for adding actions menu items into the context menu
	 * @param {Zarafa.plugins.owncloud.ui.OwncloudGridContextMenu} contextmenu This contextmenu
	 */
	/**
	 * @insert context.owncloud.contextmenu.options
	 * Insertion point for adding options menu items into the context menu
	 * @param {Zarafa.plugins.owncloud.ui.OwncloudGridContextMenu} contextmenu This contextmenu
	 */

	/**
	 * @cfg {Zarafa.plugins.owncloud.context.OwncloudContext} context The context to which this panel belongs
	 */
	context : undefined,

	/**
	 * The {@link Zarafa.plugins.owncloud.OwncloudContextModel} which is obtained from the {@link #context}.
	 * @property
	 * @type Zarafa.plugins.owncloud.context.OwncloudContextModel
	 */
	model : undefined,
	
	/**
	 * The {@link Zarafa.plugins.owncloud.ui.OwncloudFileGrid} which is obtained from the {@link #config}.
	 * @property
	 * @type Zarafa.plugins.owncloud.ui.OwncloudFileGrid
	 */
	grid : undefined,

	/**
	 * @constructor
	 * @param {Object} config Configuration object
	 */
	constructor : function(config) {
		config = config || {};

		if (!Ext.isDefined(config.model) && Ext.isDefined(config.context))
			config.model = config.context.getModel();
		
		Ext.applyIf(config, {
			items: [
				this.createContextActionItems(),
				{ xtype: 'menuseparator' },
				container.populateInsertionPoint('context.owncloudcontext.contextmenu.actions', this),
				{ xtype: 'menuseparator' },
				container.populateInsertionPoint('context.owncloudcontext.contextmenu.options', this)
			]
		});

		Zarafa.plugins.owncloud.ui.OwncloudFileGridContextMenu.superclass.constructor.call(this, config);
	},
	
	/**
	 * Apply the {@link #emptySelectOnly}, {@link #nonEmptySelectOnly}, {@link #singleSelectOnly}
	 * and {@link #multiSelectOnly} filters to determine if the item must be {@link #setDisabled disabled}
	 * or not.
	 * @private
	 */
	applyItemFilter : function(records, singleSelectOnly, fileOnly, noRoot) {
		var visible = true;
		
		if (singleSelectOnly) {
			if (!Ext.isDefined(records) || (Ext.isArray(records) && records.length != 1))
				visible = false;
		}
		
		if (fileOnly) {
			for (var i = 0; i < records.length; i++) {
				var record = records[i];
				if(record.get('type') == Zarafa.plugins.owncloud.data.FileTypes.FOLDER) {
					visible = false;
					break;
				}
			}
		}
		
		if (noRoot) {
			for (var i = 0; i < records.length; i++) {
				var record = records[i];
				if(record.get('id') == (container.getSettingsModel().get('zarafa/v1/contexts/owncloud/owncloud_path') + "/") || record.get('filename') == "..") {
					visible = false;
					break;
				}
			}
		}
		
		return visible;
	},

	/**
	 * Create the Action context menu items
	 * @return {Zarafa.core.ui.menu.ConditionalItem|Array} The list of Action context menu items
	 * @private
	 */
	createContextActionItems : function() {
		return [{
			xtype: 'zarafa.conditionalitem',
			text : dgettext('plugin_owncloud', 'Open'),
			iconCls : 'icon_open',
			handler: this.onContextItemOpen,
			beforeShow : function(item, records) {
				item.setVisible(this.applyItemFilter(records, true, false, false));
			},
			scope: this
		},
		{
			xtype: 'zarafa.conditionalitem',
			text : dgettext('plugin_owncloud', 'Rename'),
			iconCls : 'icon_rename',
			handler: this.onContextItemRename,
			beforeShow : function(item, records) {
				item.setVisible(this.applyItemFilter(records, true, false, true));
			},
			scope: this
		},
		{
			xtype: 'zarafa.conditionalitem',
			text : dgettext('plugin_owncloud', 'Attach to mail'),
			iconCls : 'icon_replyEmail',
			handler: this.onContextItemAttach,
			beforeShow : function(item, records) {
				var visible = this.applyItemFilter(records, false, true, true);
				
				var max_file_size = container.getSettingsModel().get('zarafa/v1/main/attachments/max_attachment_size');
				for (var i = 0; i < records.length; i++) {
					var record = records[i];
					if(record.get('message_size') > max_file_size) {
						visible = false;
						break;
					}
				}
				
				item.setVisible(visible);
			},
			scope: this
		},
		{
			xtype: 'zarafa.conditionalitem',
			text : dgettext('plugin_owncloud', 'Delete'),
			iconCls : 'icon_delete',
			handler: this.onContextItemDelete,
			beforeShow : function(item, records) {
				item.setVisible(this.applyItemFilter(records, false, false, true));
			},
			scope: this
		},
		{
			xtype: 'zarafa.conditionalitem',
			text : dgettext('plugin_owncloud', 'Info'),
			iconCls : 'icon_info',
			disabled : Zarafa.plugins.owncloud.data.ComponentBox.getContext().getCurrentViewMode() == Zarafa.plugins.owncloud.data.ViewModes.NO_PREVIEW ? false : true,
			handler: this.onContextItemInfo,
			beforeShow : function(item, records) {
				item.setVisible(this.applyItemFilter(records, true, false, true));
			},
			scope: this
		}];
	},

	/**
	 * Event handler which is called when the user selects the 'Open'
	 * item in the context menu. This will open the item in a new panel.
	 * @private
	 */
	onContextItemOpen : function() {
		Zarafa.plugins.owncloud.data.Actions.openOwncloudContent(this.records);
	},
	
	/**
	 * Event handler which is called when the user selects the 'Delete'
	 * item in the context menu. This will delete all selected records.
	 * @private
	 */
	onContextItemDelete : function() {
		var allowDelete = true;
		
		Ext.each(this.records, function(record) {
			if(record.get('id') == (container.getSettingsModel().get('zarafa/v1/contexts/owncloud/owncloud_path') + "/") || record.get('filename') == "..") {
				allowDelete = false;
			}
		}, this);
		
		var askOnDelete = container.getSettingsModel().get('zarafa/v1/contexts/owncloud/ask_before_delete');
		
		if(allowDelete) {
			if(askOnDelete) {
				Ext.MessageBox.confirm(dgettext('plugin_owncloud', 'Confirm deletion'), dgettext('plugin_owncloud', 'Are you sure?'), function showResult(btn) {
					if(btn == 'yes') {
						Zarafa.common.Actions.deleteRecords(this.records);
						Zarafa.plugins.owncloud.data.Actions.refreshNavigatorTree();
					}
				}, this);
			} else {
				Zarafa.common.Actions.deleteRecords(this.records);
				Zarafa.plugins.owncloud.data.Actions.refreshNavigatorTree();
			}
		}
		
	},
	
	/**
	 * Event handler which is called when the user selects the 'Info'
	 * item in the context menu. This will load the preview panel with infos about the file
	 * @private
	 */
	onContextItemInfo : function() {
		var count = this.records.length;
		var record = undefined;
		
		if (count == 1)
			record = this.records[0];
	
		var config = Ext.applyIf({}, {
			modal : true,
			record : record
		});
		
		var componentType = Zarafa.core.data.SharedComponentType['zarafa.plugins.owncloud.fileinfopanel'];
		Zarafa.core.data.UIFactory.openLayerComponent(componentType, undefined, config);
	},
	
	/**
	 * Event handler which is called when the user selects the 'Rename'
	 * item in the context menu. This will load the preview panel with infos about the file
	 * @private
	 */
	onContextItemRename : function() {
		Zarafa.plugins.owncloud.data.Actions.openRenameDialog(this.model, this.records[0]);
	},
	
	/**
	 * Event handler which is called when the user selects the 'Attach to Mail'
	 * item in the context menu. 
	 * @private
	 */
	onContextItemAttach : function() {
		var emailRecord = container.getContextByName("mail").getModel().createRecord();
		var idsList = [];
		var attachmentStore = emailRecord.getAttachmentStore();

		Ext.each(this.records, function(record) {
			idsList.push(record.get('id'));
		}, this);
		
		container.getNotifier().notify('info.owncloud', dgettext('plugin_owncloud', 'Attaching'), dgettext('plugin_owncloud', 'Creating email... Please wait!'));
		
		try {
			container.getRequest().singleRequest(
				'owncloudmodule',
				'download-to-tmp',
				{
					ids : idsList,
					dialog_attachments: attachmentStore.getId()
				},
				new Zarafa.plugins.owncloud.data.ResponseHandler({
					successCallback : function (response) {
						Zarafa.plugins.owncloud.data.Actions.openCreateMailContent(emailRecord,response);
					}
				})
			);
		} catch (e) {
			Zarafa.common.dialogs.MessageBox.show({
				title   : dgettext('plugin_owncloud', 'Warning'),
				msg     : e.getMessage(),
				icon    : Zarafa.common.dialogs.MessageBox.WARNING,
				buttons : Zarafa.common.dialogs.MessageBox.OK
			});
		}
	}
});

Ext.reg('zarafa.owncloudfilegridcontextmenu', Zarafa.plugins.owncloud.ui.OwncloudFileGridContextMenu);
/**
 * OwncloudFileGrid.js zarafa owncloud plugin
 *
 * Author: Christoph Haas <christoph.h@sprinternet.at>
 * Copyright (C) 2012-2013 Christoph Haas
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

Ext.namespace('Zarafa.plugins.owncloud.ui');

/**
 * @class Zarafa.plugins.owncloud.ui.OwncloudFileTable
 * @extends Ext.grid.GridPanel
 * The main gridpanel for our data
 */
Zarafa.plugins.owncloud.ui.OwncloudFileGrid = Ext.extend(Zarafa.common.ui.grid.GridPanel, {
	/**
	 * @cfg {Zarafa.plugins.owncloud.context.OwncloudContext} context The context to which this panel belongs
	 */
	context : undefined,
	
	/**
	 * The {@link Zarafa.plugins.owncloud.context.OwncloudContextModel} which is obtained from the {@link #context}.
	 * @property
	 * @type Zarafa.plugins.owncloud.context.OwncloudContextModel
	 */
	model : undefined,
	
	/**
	 * The dropZone used by this grid if drop is enabled
	 * @property
	 */
	dropTarget : undefined,
		
	/**
	 * @constructor
	 * @param {Object} config
	 */
	constructor : function(config) {
		config = config || {};
		
		if (!Ext.isDefined(config.model) && Ext.isDefined(config.context))
			config.model = config.context.getModel();

		if (!Ext.isDefined(config.store) && Ext.isDefined(config.model))
			config.store = config.model.getStore();
			
		config.store = Ext.StoreMgr.lookup(config.store);
		
		Ext.applyIf(config, {
			xtype : 'zarafa.owncloudfilegrid',
			ddGroup : 'dd.owncloudrecord',
			enableDragDrop: true,
			border : false,
			stateful : true,
			statefulRelativeDimensions : false,
			loadMask : this.initLoadMask(),
			viewConfig : this.initViewConfig(),
			sm : this.initSelectionModel(),
			cm : this.initColumnModel(),
			keys : {
				key : Ext.EventObject.DELETE,
				handler : this.onKeyDelete,
				scope : this
			}
		});
		Zarafa.plugins.owncloud.ui.OwncloudFileGrid.superclass.constructor.call(this, config);
		
	},
	
	/**
	 * Initialize event handlers
	 * @private
	 */
	initEvents : function() {
		Zarafa.mail.ui.MailGrid.superclass.initEvents.call(this);

		this.mon(this, 'cellcontextmenu', this.onCellContextMenu, this);
		this.mon(this, 'rowbodycontextmenu', this.onRowBodyContextMenu, this);
		//this.mon(this, 'cellclick', this.onCellClick, this);
		this.mon(this, 'rowdblclick', this.onRowDblClick, this);
		this.mon(this, 'afterrender', this.initTropTarget, this);
		
		// Add a buffer to the following 2 event handlers. These are influenced by Extjs when a record
		// is removed from the store. However removing of records isn't performed in batches. This means
		// that wee need to offload the event handlers attached to removing of records in case that
		// a large batch of records is being removed.
		this.mon(this.getSelectionModel(), 'beforerowselect', this.onBeforeRowSelect, this, { buffer : 1 });
		this.mon(this.getSelectionModel(), 'rowselect', this.onRowSelect, this, { buffer : 1 });
		this.mon(this.getSelectionModel(), 'selectionchange', this.onSelectionChange, this, { buffer : 1 });

		//this.mon(this.model, 'recordselectionchange', this.onRecordSelectionChange, this);

		this.mon(this.context, 'viewmodechange', this.onContextViewModeChange, this);
		this.onContextViewModeChange(this.context, this.context.getCurrentViewMode());
	},

	/**
	 * Initialize the {@link Ext.grid.GridPanel.loadMask} field
	 *
	 * @return {Ext.LoadMask} The configuration object for {@link Ext.LoadMask}
	 * @private
	 */
	initLoadMask : function() {
		return {
			msg : dgettext('plugin_owncloud', 'Loading files') + '...'
		};
	},

	/**
	 * Initialize the {@link Ext.grid.GridPanel#viewConfig} field
	 *
	 * @return {Ext.grid.GridView} The configuration object for {@link Ext.grid.GridView}
	 * @private
	 */
	initViewConfig : function() {
		return {
			// enableRowBody is used for enabling the rendering of
			// the second row in the compact view model. The actual
			// rendering is done in the function getRowClass.
			//
			// NOTE: Even though we default to the extended view,
			// enableRowBody must be enabled here. We disable it
			// later in onContextViewModeChange(). If we set false
			// here, and enable it later then the row body will never
			// be rendered. So disabling after initializing the data
			// with the rowBody works, but the opposite will not.
			enableRowBody : false,
			
			// We need a rowselector depth of 15 because of the nested
			// table in the rowBody.
			rowSelectorDepth : 15
		};
	},

	/**
	 * Initialize the {@link Ext.grid.GridPanel.sm SelectionModel} field
	 *
	 * @return {Ext.grid.RowSelectionModel} The subclass of {@link Ext.grid.AbstractSelectionModel}
	 * @private
	 */
	initSelectionModel : function() {
		return new Ext.grid.RowSelectionModel({
			singleSelect : false
		});
	},

	/**
	 * Initialize the {@link Ext.grid.GridPanel.cm ColumnModel} field.
	 *
	 * @return {Ext.grid.ColumnModel} The {@link Ext.grid.ColumnModel} for this grid
	 * @private
	 */
	initColumnModel : function() {
		return new Zarafa.plugins.owncloud.ui.OwncloudFileGridColumnModel();
	},
	
	/**
	 * Initialize the {@link Ext.dd.DropTarget dropTarget}
	 *
	 * @return {Ext.grid.ColumnModel} The {@link Ext.dd.DropTarget dropTarget} for this grid
	 * @private
	 */
	initTropTarget : function () {
		var gridDropTargetEl = this.getView().el.dom.childNodes[0].childNodes[1]
		this.dropTarget = new Ext.dd.DropTarget(gridDropTargetEl, {
			ddGroup    : 'dd.owncloudrecord',
			copy       : false,
			gridStore  : this.getStore(),
			gridSM     : this.getSelectionModel(),
			notifyDrop : function(ddSource, e, data){
				var cellindex = ddSource.getDragData(e).rowIndex;
				
				if(typeof cellindex !== "undefined" && this.gridStore.getAt(cellindex).get('type') == Zarafa.plugins.owncloud.data.FileTypes.FOLDER) {
					// Disable all selected records
					Ext.each(data.selections, function(record) {
						record.setDisabled(true);
					});
					
					return Zarafa.plugins.owncloud.data.Actions.moveRecords(data.selections,this.gridStore.getAt(cellindex));
				} else 
					return false;
			},
			notifyOver : function(ddSource, e, data){
				var cellindex = ddSource.getDragData(e).rowIndex;
				
				if(typeof cellindex !== "undefined") {
					// check if we are over a folder - if so, allow drop
					if(this.gridStore.getAt(cellindex).get('type') == Zarafa.plugins.owncloud.data.FileTypes.FOLDER)
						 return this.dropAllowed;
				}
				return this.dropNotAllowed;
			},
			notifyEnter : function(ddSource, e, data){
				var cellindex = ddSource.getDragData(e).rowIndex;
				
				if(typeof cellindex !== "undefined") {
					// check if we are over a folder - if so, allow drop
					if(this.gridStore.getAt(cellindex).get('type') == Zarafa.plugins.owncloud.data.FileTypes.FOLDER)
						 return this.dropAllowed;
				}
				return this.dropNotAllowed;
			}
		});
		
		this.getView().dragZone.onBeforeDrag = function (data, e){
			return !data.grid.getStore().getAt(data.rowIndex).getDisabled();
		}
	},
	
	/**
	 * Event handler which is fired when the {@link Zarafa.core.Context} fires the
	 * {@link Zarafa.core.Context#viewmodechange viewmodechange} event. This will check
	 * where the preview panel is located, and if needed change the
	 * {@link Ext.grid.Column columns} inside the {@link Ext.grid.ColumnModel ColumnModel}
	 * of the {@link Zarafa.plugins.owncloud.ui.OwncloudFileGrid OwncloudFileGrid}. Either use the extended (and more flexible)
	 * set or the more compact set.
	 *
	 * @param {Zarafa.core.Context} context The context which fired the event
	 * @param {Zarafa.plugins.owncloud.data.ViewModes} newViewMode The new active mode
	 * @param {Zarafa.plugins.owncloud.data.ViewModes} oldViewMode The previous mode
	 * @private
	 */
	onContextViewModeChange : function(context, newViewMode, oldViewMode) {
		var compact = newViewMode === Zarafa.plugins.owncloud.data.ViewModes.RIGHT_PREVIEW;

		this.getColumnModel().setCompactView(compact);
	},

	/**
	 * Event handler for the {@link #beforeconfigchange} event which is fired at the start of
	 * {@link Zarafa.common.ui.grid.ColumnModel#setConfig}. At this time we can
	 * check which columns should be activated based on the {@link #currentEntryId}.
	 *
	 * @param {Ext.gridColumnModel} columnModel The model which is being configured
	 * @param {Object} config The configuration object
	 * @private
	 */
	onBeforeConfigChange : function(columnModel, config) {
		if (!this.currentEntryId)
			return;
		
		// TODO: code...
		
		Zarafa.plugins.owncloud.ui.OwncloudFileGrid.superclass.onBeforeConfigChange.apply(this, arguments);
	},
	
	/**
	 * Event handler which is triggered when the user opems the context menu.
	 *
	 * There are some selection rules regarding the context menu. If no rows where
	 * selected, the row on which the context menu was requested will be marked
	 * as selected. If there have been rows selected, but the context menu was
	 * requested on a different row, then the old selection is lost, and the new
	 * row will be selected. If the row on which the context menu was selected is
	 * part of the previously selected rows, then the context menu will be applied
	 * to all selected rows.
	 *
	 * @param {Zarafa.plugins.owncloud.ui.OwncloudFile} grid The grid which was right clicked
	 * @param {Number} rowIndex The index number of the row which was right clicked
	 * @param {Number} cellIndex The index number of the column which was right clicked
	 * @param {Ext.EventObject} event The event structure
	 * @private
	 */
	onCellContextMenu : function(grid, rowIndex, cellIndex, event) {
		var sm = this.getSelectionModel();
		var cm = this.getColumnModel();

		if (sm.hasSelection()) {
			// Some records were selected...
			if (!sm.isSelected(rowIndex)) {
				// But none of them was the record on which the
				// context menu was invoked. Reset selection.
				sm.clearSelections();
				sm.selectRow(rowIndex);
			}
		} else {
			// No records were selected,
			// select row on which context menu was invoked
			sm.selectRow(rowIndex);
		}

		var column = {};
		// Take into account that the function onRowBodyContextMenu passes -1 as the column index.
		if(cellIndex >= 0)
			column = cm.getColumnById(cm.getColumnId(cellIndex));
			
		var records = sm.getSelections();
		
		var show = true;
		Ext.each(records, function (record) {
			if(record.getDisabled() == true) {
				show = false;
				return;
			}
		});

		if(show) {
			Zarafa.core.data.UIFactory.openDefaultContextMenu(records, { position : event.getXY(), context : this.context, grid : this });
		}
	},

	/**
	 * Event handler which is triggered when the user opems the context menu.
	 *
	 * This will call {@link onCellContextMenu} and pass -1 for the column index to prevent it 
	 * showing a special context menu if one would be set for specific columns.

	 *
	 * @param {Zarafa.plugins.owncloud.ui.OwncloudFile} grid The grid which was right clicked
	 * @param {Number} rowIndex The index number of the row which was right clicked
	 * @param {Ext.EventObject} event The event structure
	 * @private
	 */
	onRowBodyContextMenu : function(grid, rowIndex, event) {
		this.onCellContextMenu(grid, rowIndex, -1, event);
	},
	
	/**
	 * Event handler which is triggered when the user double-clicks on a particular item in the
	 * grid. This will update the store which 
	 * contains the selected item.
	 *
	 * @param {Grid} grid The Grid on which the user double-clicked
	 * @param {Number} rowIndex The Row number on which was double-clicked.
	 * @param {Ext.EventObject} e The event object
	 * @private
	 */
	onRowDblClick : function(grid, rowIndex, e) {
		var record = grid.store.getAt(rowIndex);
		var navpanel = Zarafa.plugins.owncloud.data.ComponentBox.getNavigatorTreePanel();
		
		if(record.get('type') == Zarafa.plugins.owncloud.data.FileTypes.FOLDER) {
			this.store.loadPath(record.get('id'));
			var node = navpanel.getNodeById(record.get('id'));
			
			if(typeof node !== "undefined")
				node.reload();
		} else
			Zarafa.plugins.owncloud.data.Actions.downloadItem([record]);
	},
	
	/**
	 * Event handler which is triggered when the user uses the delete button on a particular item in the
	 * grid. This will update the store which 
	 * contains the selected item.
	 *
	 * @param {Grid} grid The Grid on which the user double-clicked
	 * @param {Number} rowIndex The Row number on which was double-clicked.
	 * @param {Ext.EventObject} e The event object
	 * @private
	 */
	onKeyDelete : function(key, event) {
		var selections = this.getSelectionModel().getSelections();
		var allowDelete = true;
		
		if (!Ext.isEmpty(selections)) {
			Ext.each(selections, function(record) {
				if(record.get('id') == (container.getSettingsModel().get('zarafa/v1/contexts/owncloud/owncloud_path') + "/") || record.get('filename') == ".." || record.getDisabled() == true)
					allowDelete = false;
			}, this);
			
			var askOnDelete = container.getSettingsModel().get('zarafa/v1/contexts/owncloud/ask_before_delete');
			
			if(allowDelete) {
				if(askOnDelete) {
					Ext.MessageBox.confirm('Confirm deletion', 'Are you sure?', function showResult(btn){
						if(btn == 'yes') {
							Zarafa.common.Actions.deleteRecords(this.getSelectionModel().getSelections());
							Zarafa.plugins.owncloud.data.Actions.refreshNavigatorTree();
						}
					}, this);
				} else {
					Zarafa.common.Actions.deleteRecords(selections);
					Zarafa.plugins.owncloud.data.Actions.refreshNavigatorTree();
				}
			}
		}
	},
	
	/**
	 * Event handler which is trigggerd before the user selects a row from the {@link Ext.grid.GridPanel}.
	 * This will updates the {@link Zarafa.owncloud.OwncloudContextModel OwncloudContextModel} with the record which 
	 * was selected in the grid for preview
	 *
	 * @param {Ext.grid.RowSelectionModel} selectionModel The selection model used by the grid.
	 * @param {Integer} rowNumber The row number which is selected in the selection model
	 * @param {Boolean} False if other selections will be cleared
	 * @param {Ext.data.Record} record The record which is selected for preview.
	 * @private
	 */
	onBeforeRowSelect: function (sm, rowIndex, keepExisting, record) {
		return !record.getDisabled();
	},
	
	/**
	 * Event handler which is trigggerd when the user selects a row from the {@link Ext.grid.GridPanel}.
	 * This will updates the {@link Zarafa.owncloud.OwncloudContextModel OwncloudContextModel} with the record which 
	 * was selected in the grid for preview
	 *
	 * @param {Ext.grid.RowSelectionModel} selectionModel The selection model used by the grid.
	 * @param {Integer} rowNumber The row number which is selected in the selection model
	 * @param {Ext.data.Record} record The record which is selected for preview.
	 * @private
	 */
	onRowSelect : function(selectionModel, rowNumber, record) {
		var viewMode = this.context.getCurrentViewMode();
		
		var count = selectionModel.getCount();

		if(viewMode != Zarafa.plugins.owncloud.data.ViewModes.NO_PREVIEW) {
			if (count == 0)
				this.model.setPreviewRecord(undefined);
			else if (count == 1 && selectionModel.getSelected() === record) {
				if(record.get('id') != (container.getSettingsModel().get('zarafa/v1/contexts/owncloud/owncloud_path') + "/") && record.get('filename') != "..")
					this.model.setPreviewRecord(record);
				else
					this.model.setPreviewRecord(undefined);
			}
		}
	},
	
	/**
	 * Event handler which is triggered when the {@link Ext.grid.GridPanel grid}
	 * {@link Zarafa.core.data.IPMRecord record} selection is changed. This will inform
	 * the {@link Zarafa.owncloud.OwncloudContextModel contextmodel} about the change.
	 *
	 * @param {Ext.grid.RowSelectionModel} selectionModel The selection model used by the grid.
	 * @private
	 */
	onSelectionChange : function(selectionModel) {
		var selections = selectionModel.getSelections();
		var viewMode = this.context.getCurrentViewMode();

		this.model.setSelectedRecords(selections);
		if(viewMode != Zarafa.plugins.owncloud.data.ViewModes.NO_PREVIEW) {
			if (Ext.isEmpty(selections))
				this.model.setPreviewRecord(undefined);
		}
	}
	
	// TODO: more eventhandlers...
});

Ext.reg('zarafa.owncloudfilegrid',Zarafa.plugins.owncloud.ui.OwncloudFileGrid);/**
 * OwncloudMainPanel.js zarafa owncloud plugin
 *
 * Author: Christoph Haas <christoph.h@sprinternet.at>
 * Copyright (C) 2012-2013 Christoph Haas
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

Ext.namespace('Zarafa.plugins.owncloud.ui');

/**
 * @class Zarafa.plugins.owncloud.ui.OwncloudMainPanel
 * @extends Zarafa.common.ui.ContextMainPanel
 * @xtype zarafa.owncloudmainpanel
 *
 * this class will be containing all the views that will be created for ownclouds folder
 * main panel for the owncloud content context
 */
Zarafa.plugins.owncloud.ui.OwncloudMainPanel = Ext.extend(Zarafa.common.ui.ContextMainPanel, {
	// Insertion points for this class
	/**
	 * @insert context.owncloud.toolbar.item
	 * Insertion point for populating Owncloud context's main toolbar.
	 * This item is only visible when this context is active.
	 * @param {Zarafa.plugins.owncloud.ui.OwncloudMainPanel} panel This panel
	 */
	/**
	 * @insert context.owncloud.toolbar.paging
	 *
	 * Insertion point for populating owncloud context's toolbar with extra
	 * pagination buttons. This can be used to replace the default {@link Ext.PagingToolbar}
	 * with an alternative. Owncloud that by default all paging toolbars will be visible, and
	 * hiding a particular toolbar is the responsibility of the new pagers.
	 * @param {Zarafa.plugins.owncloud.ui.OwncloudMainPanel} panel This panel
	 */
	/**
	 * @insert context.owncloud.views
	 * Insertion point for adding views within the main panel of owncloud context.
	 * This insertion point should be used in combination with 'main.maintoolbar.view.owncloud'
	 * insertion point, and also view should set its store in the config object, the reference of
	 * {@link Zarafa.plugins.owncloud.OwncloudContextModel OwncloudContextModel} is passed as parameter of this
	 * insertion point.
	 * @param {Zarafa.plugins.owncloud.ui.OwncloudMainPanel} mainpanel This mainpanel
	 * @param {Zarafa.plugins.owncloud.OwncloudContext} context The context for this panel
	 */
	 
	/**
	 * The main panel in which the various views are located.
	 * @property
	 * @type Zarafa.core.ui.SwitchViewContentContainer
	 */
	viewPanel : undefined,
	
	/**
	 * @constructor
	 * @param owncloudcontext
	 */
	constructor : function(config) {
		config = config || {};
		
		Ext.applyIf(config, {
			xtype : 'zarafa.owncloudmainpanel',
			layout : 'zarafa.switchborder',
			
			items : [
				this.initFileGrid(config),
				this.initPreviewPanel(config.context)
			]
		});
		
		Zarafa.plugins.owncloud.ui.OwncloudMainPanel.superclass.constructor.call(this,config);
	},
	
	/**
	 * Initializes the {@link Zarafa.plugins.owncloud.ui.OwncloudFileGrid OwncloudFileGrid}
	 *
	 * @param {Object} config Configuration object
	 * @return {Zarafa.plugins.owncloud.ui.OwncloudFileGrid}
	 * @private
	 */
	initFileGrid : function(config) {
		return {
			xtype: 'panel',
			ref: 'owncloudGridpanel',
			layout: 'zarafa.collapsible',
			cls : 'zarafa-context-mainpanel',
			minWidth : 200,
			minHeight: 200,
			region : 'center',
			collapsible : false,
			split : true,
			items: [{
				xtype: 'zarafa.switchviewcontentcontainer',
				ref: '../viewPanel',
				layout : 'card',
				lazyItems : this.initViews(config.context)
			}],			
			tbar : {
				xtype: 'zarafa.owncloudtoolbar',
				defaultTitle : dgettext('plugin_owncloud', 'Files'),
				height:33,
				context : config.context
			}
		};
	},
	
	/**
	 * Function will initialize all views associated with owncloud context
	 * it will also get views added through 3rd party plugins and add it here
	 * @param {Zarafa.plugins.owncloud.OwncloudContextModel} model data part of owncloud context
	 * @return {Array} array of config objects of different views
	 * @private
	 */
	initViews : function(context) {
		// add the standard available views
		var allViews = [{
			xtype: 'zarafa.owncloudfilegrid',
			flex: 1,
			id : 'owncloud-file-grid',
			anchor: '100%',
			context : context
		}];

		var additionalViewItems = container.populateInsertionPoint('context.owncloud.views', this, context);
		allViews = allViews.concat(additionalViewItems);

		return allViews;
	},

	/**
	 * Initializes the {@link Zarafa.core.ui.PreviewPanel PreviewPanel}
	 *
	 * @param {Zarafa.mail.OwncloudContext} context The Owncloud Context
	 * @return {Zarafa.core.ui.PreviewPanel}
	 * @private
	 */
	initPreviewPanel : function(context) {
		return {
			xtype: 'zarafa.owncloudpreviewpanel',
			ref: 'owncloudPreview',
			region : 'south',
			split : true,
			context: context
		};
	},

	/**
	 * Function called by Extjs when the panel has been {@link #render rendered}.
	 * At this time all events can be registered.
	 * @private
	 */
	initEvents : function() {
		if (Ext.isDefined(this.context)) {
			this.mon(this.context, 'viewchange', this.onViewChange, this);
			this.mon(this.context, 'viewmodechange', this.onViewModeChange, this);

			this.onViewChange(this.context, this.context.getCurrentView());
			this.onViewModeChange(this.context, this.context.getCurrentViewMode());
		}
	},

	/**
	 * Event handler which is fired when the currently active view inside the {@link #context}
	 * has been updated. This will update the call
	 * {@link #viewPanel}#{@link Zarafa.core.ui.SwitchViewContentContainer#switchView}
	 * to make the requested view active.
	 *
	 * @param {Zarafa.core.Context} context The context which fired the event.
	 * @param {Zarafa.plugins.owncloud.data.Views} newView The ID of the selected view.
	 * @param {Zarafa.plugins.owncloud.data.Views} oldView The ID of the previously selected view.
	 */
	onViewChange : function(context, newView, oldView) {
		switch (newView) {
			case Zarafa.plugins.owncloud.data.Views.LIST:
				this.viewPanel.switchView('owncloud-file-grid');
				break;
		}
	},

	/**
	 * Event handler which is fired when the {@link Zarafa.core.Context} fires the
	 * {@link Zarafa.core.Context#viewmodechange viewmodechange} event. This will
	 * convert the configured {@link Zarafa.plugins.owncloud.data.ViewModes mode} to a
	 * {@link Zarafa.common.ui.layout.SwitchBorderLayout.Orientation orientation}
	 * to be {@link Zarafa.common.ui.layout.SwitchBorderLayout.setOrientation applied}
	 * to the {@link #layout}.
	 * @param {Zarafa.core.Context} context The context which fired the event
	 * @param {Zarafa.plugins.owncloud.data.ViewModes} newViewMode The new active mode
	 * @param {Zarafa.plugins.owncloud.data.ViewModes} oldViewMode The previous mode
	 * @private
	 */
	onViewModeChange : function(context, newViewMode, oldViewMode) {
		var orientation;

		switch (newViewMode) {
			case Zarafa.plugins.owncloud.data.ViewModes.NO_PREVIEW:
				orientation = Zarafa.common.ui.layout.SwitchBorderLayout.Orientation.OFF;
				break;
			case Zarafa.plugins.owncloud.data.ViewModes.RIGHT_PREVIEW:
				orientation = Zarafa.common.ui.layout.SwitchBorderLayout.Orientation.HORIZONTAL;
				break;
			case Zarafa.plugins.owncloud.data.ViewModes.BOTTOM_PREVIEW:
				orientation = Zarafa.common.ui.layout.SwitchBorderLayout.Orientation.VERTICAL;
				break;
			case Zarafa.plugins.owncloud.data.ViewModes.SEARCH:
				return;
		}

		// This function could be called when the layout has not yet
		// been instantiated. In that case we update the layoutConfig
		// so it will be automatically picked up by the layout when
		// it needs it.
		var layout = this.getLayout();
		if (!Ext.isFunction(layout.setOrientation)) {
			if (Ext.isString(layout))
				this.layoutConfig = Ext.apply(this.layoutConfig || {}, { orientation : orientation });
			else
				this.layout.orientation = orientation;
		} else
			layout.setOrientation(orientation);
	}
});
//register xtype of owncloud main panel
Ext.reg('zarafa.owncloudmainpanel',Zarafa.plugins.owncloud.ui.OwncloudMainPanel);
/**
 * OwncloudContextModel.js zarafa owncloud plugin
 *
 * Author: Christoph Haas <christoph.h@sprinternet.at>
 * Copyright (C) 2012-2013 Christoph Haas
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
 
Ext.namespace('Zarafa.plugins.owncloud.context');

/**
 * @class Zarafa.plugins.owncloud.context.OwncloudContextModel
 * @extends Zarafa.core.ContextModel
 * class will instantiate {@link Zarafa.plugins.owncloud.OwncloudStore OwncloudStore} object
 */
Zarafa.plugins.owncloud.context.OwncloudContextModel = Ext.extend(Zarafa.core.ContextModel, {
	/**
	 * @constructor
	 * @param {Object} config Configuration object
	 */
	constructor : function(config) {
		config = config || {};
		
		if(!Ext.isDefined(config.store))
			config.store = new Zarafa.plugins.owncloud.data.OwncloudStore();
		
		Zarafa.plugins.owncloud.context.OwncloudContextModel.superclass.constructor.call(this, config);
	},
	
	/**
	 * Create a new {@link Zarafa.core.data.IPMRecord IPMRecord}.
	 * @param {String} parentid id of the parent folder
	 * @return {Zarafa.core.data.IPMRecord} The new {@link Zarafa.core.data.IPMRecord IPMRecord}.
	 */
	createRecord : function(parentid) {
		parentid = parentid || "root";
		
		var record = Zarafa.core.data.RecordFactory.createRecordObjectByMessageClass('IPM.Owncloud', {
			store_entryid: "owncloud",
			parent_entryid: parentid
		});
		
		return record;
	},
	
	/**
	 * Event handler which is executed right before the {@link #datamodechange}
	 * event is fired. This allows subclasses to initialize the {@link #store}.
	 * This will apply a restriction to the {@link #store} if needed.
	 *
	 * @param {Zarafa.contact.ContactContextModel} model The model which fired the event.
	 * @param {Zarafa.contact.data.DataModes} newMode The new selected DataMode.
	 * @param {Zarafa.contact.data.DataModes} oldMode The previously selected DataMode.
	 * @private
	 */
	onDataModeChange : function(model, newMode, oldMode) {
		//Zarafa.plugins.owncloud.context.OwncloudContextModel.superclass.onDataModeChange.call(this, model, newMode, oldMode);
	},
	
	/**
	 * Update the current preview {@link Zarafa.core.data.IPMRecord}
	 * This will fire the event {@link #previewrecordchange}.
	 *
	 * @param {mixed} record The record which is set as preview or false to refresh the old record
	 * @param {Boolean} refresh (optinal) true to just refresh the old record
	 * in the {@link #lastPreviewedRecord}.
	 */
	setPreviewRecord : function(record, refresh) {
		if(container.getCurrentContext().getName() == "owncloudcontext") { // otherwhise getContentPanel() will return the wrong panel the first time...
			var previewPanel = Zarafa.plugins.owncloud.data.ComponentBox.getPreviewPanel();
			var panelConstructor;
			
			if(refresh && this.previewRecord) {
				// Just do a complete refresh, clearing all UI components
				// which might be active inside the panel.
				panelConstructor = container.getSharedComponent(Zarafa.core.data.SharedComponentType['common.preview'], this.previewRecord);
				
				previewPanel.removeAll();
				if (panelConstructor) {
					previewPanel.add(new panelConstructor());
					previewPanel.doLayout();
					previewPanel.fileinfo.update(this.previewRecord);
				}
				
			} else if (this.previewRecord !== record) {
				this.previewRecord = record;
				
				if (Ext.isDefined(record)) {
					panelConstructor = container.getSharedComponent(Zarafa.core.data.SharedComponentType['common.preview'], record);
					
					if (panelConstructor && previewPanel.fileinfo instanceof panelConstructor) {
						previewPanel.fileinfo.update(record); // panel exists... just update
					} else {
						// Do a complete refresh, clearing all UI components
						// which might be active inside the panel.
						previewPanel.removeAll();
						if (panelConstructor) {
							previewPanel.add(new panelConstructor());
							previewPanel.doLayout();
							previewPanel.fileinfo.update(record);
						}
					}
				}
			}
		}
	},
	
	/**
	 * Returns the default {@link Zarafa.hierarchy.data.MAPIFolderRecord folder} which is
	 * used within the current selection of folders. If this {@link Zarafa.core.ContextModel ContextModel} is not enabled
	 * then this function will return default folder of this context, and if not enabled then it will return
	 * currently selected folder in the ContextModel.
	 * @return {Zarafa.hierarchy.data.MAPIFolderRecord} The default folder
	 */
	getDefaultFolder : function() {
		var pseudoFolder;
		var icon_id = container.getSettingsModel().get('zarafa/v1/contexts/owncloud/iconid');
		var name = container.getSettingsModel().get('zarafa/v1/plugins/owncloud/button_name');
		
		/* this is a workaround to get the initial name and icon loading of the context tab working */
		// FIXME: this should really be improved!
		pseudoFolder = {
			get : function(item) {
				if(item == "icon_index") {
					return icon_id;
				} 
				return undefined;
			},
			
			getDisplayName : function () {
				return name + " - " + dgettext('plugin_owncloud', 'Files');
			},
			
			getFullyQualifiedDisplayName : function () {
				return name + " - " + dgettext('plugin_owncloud', 'Files');
			},
			
			getParentFolder : function () {
				return undefined;
			},
			
			set : function (item, value) {
			}
		};
		
		// ContextModel is not enabled so return default folder
		return pseudoFolder;
	}
});
/**
 * OwncloudContext.js zarafa owncloud plugin
 *
 * Author: Christoph Haas <christoph.h@sprinternet.at>
 * Copyright (C) 2012-2013 Christoph Haas
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

Ext.namespace('Zarafa.plugins.owncloud.context');

/**
 * @class Zarafa.plugins.owncloud.OwncloudContext
 * @extends Zarafa.core.Context
 *
 * This class will be used as a controller between {@link Zarafa.plugins.owncloud.OwncloudContextModel OwncloudContextModel}
 * and {@link Zarafa.plugins.owncloud.ui.OwncloudMainPanel OwncloudMainPanel}
 * Context that handles displaying owncloud type messages.
 */
Zarafa.plugins.owncloud.context.OwncloudContext = Ext.extend(Zarafa.core.Context, {
	// Insertion points for this class
	/**
	 * @insert main.maintoolbar.view.owncloud
	 * Insertion point for populating the main toolbar with a View button. This item is only visible
	 * when this context is active.
	 * @param {Zarafa.mail.OwncloudContext} context This context
	 */

	/**
	 * When searching, this property marks the {@link Zarafa.core.Context#getCurrentView view}
	 * which was used before {@link #onSearchStart searching started} the view was switched to
	 * {@link Zarafa.mail.data.Views#SEARCH}.
	 * @property
	 * @type Mixed
	 * @private
	 */
	oldView : undefined,

	/**
	 * When searching, this property marks the {@link Zarafa.core.Context#getCurrentViewMode viewmode}
	 * which was used before {@link #onSearchStart searching started} the viewmode was switched to
	 * {@link Zarafa.mail.data.ViewModes#SEARCH}.
	 * @property
	 * @type Mixed
	 * @private
	 */
	oldViewMode : undefined,
	 
	/**
	 * @constructor
	 * @param {Object} config configuration object
	 */
	constructor : function(config) {
		config = config || {};

		Ext.applyIf(config, {
			name : 'owncloudcontext',
			displayName : container.getSettingsModel().get('zarafa/v1/plugins/owncloud/button_name'),
			current_view : Zarafa.plugins.owncloud.data.Views.LIST
		});
				
		// register module names...
		this.registerModules();

		// The tab in the top tabbar
		this.registerInsertionPoint('main.maintabbar.left', this.createMainTab, this);

		// The "New Owncloud" button which is available in all contexts
		this.registerInsertionPoint('main.maintoolbar.new.item', this.createNewOwncloudButton, this);

		Zarafa.plugins.owncloud.context.OwncloudContext.superclass.constructor.call(this, config);

		// add shared components
		Zarafa.core.data.SharedComponentType.addProperty('zarafa.plugins.owncloud.uploadpanel');
		Zarafa.core.data.SharedComponentType.addProperty('zarafa.plugins.owncloud.attachdialog');
		Zarafa.core.data.SharedComponentType.addProperty('zarafa.plugins.owncloud.fileinfopanel');
		
		// Add a tree control showing a list of owncloud folders to the navigation panel.
		// The control will be shown when the user selects the owncloud context from the button panel.
		this.registerInsertionPoint('navigation.center', this.createOwncloudNavigationPanel, this);
		
		// Extend the Contact and AddressBook context with email buttons
		this.registerInsertionPoint('context.addressbook.contextmenu.actions', this.createSendEmailContextItem, this);
		this.registerInsertionPoint('context.contact.contextmenu.actions', this.createSendEmailContextItem, this);
		this.registerInsertionPoint('context.contact.contactcontentpanel.toolbar.actions', this.createSendEmailButton, this);
		this.registerInsertionPoint('context.contact.distlistcontentpanel.toolbar.actions', this.createSendEmailButton, this);
	},

	/**
	 * @return {Zarafa.plugins.owncloud.context.OwncloudContextModel} the owncloud context model
	 */
	getModel : function() {
		if (!Ext.isDefined(this.model)) {
			this.model = new Zarafa.plugins.owncloud.context.OwncloudContextModel();
		}
		return this.model;
	},

	/**
	 * bid to get selected on Mapi folder selection
	 */
	bid : function(folder) {
		// Bid 1 when the folder is of the IPF.Owncloud type.
		if (folder.isContainerClass('IPF.Owncloud', true))
			return 1;

		return -1;
	},

	/**
	 * Bid for the type of shared component and the given record.
	 * @param {Zarafa.core.data.SharedComponentType} type Type of component a context can bid for.
	 * @param {Ext.data.Record} record Optionally passed record.
	 * @return {Number} The bid for the shared component
	 */
	bidSharedComponent: function(type, record) {
		var bid = -1;

		if (Ext.isArray(record))
			record = record[0];
		
		switch (type) {
			case Zarafa.core.data.SharedComponentType['zarafa.plugins.owncloud.uploadpanel']:
			case Zarafa.core.data.SharedComponentType['zarafa.plugins.owncloud.attachdialog']:
			case Zarafa.core.data.SharedComponentType['zarafa.plugins.owncloud.fileinfopanel']:
				bid = 1;
				break;
			case Zarafa.core.data.SharedComponentType['common.create']:
			case Zarafa.core.data.SharedComponentType['common.view']:
			case Zarafa.core.data.SharedComponentType['common.preview']:
				if (record instanceof Zarafa.core.data.IPMRecord && record.isMessageClass('IPM.Owncloud', true))
					bid = 1;
				break;
			case Zarafa.core.data.SharedComponentType['common.contextmenu']:
				if (record instanceof Zarafa.core.data.IPMRecord && record.isMessageClass('IPM.Owncloud', true))
					bid = 1;
				break;
			default : break;
		}
		return bid;
	},

	/**
	 * Will return the reference to the shared component.
	 * Based on the type of component requested a component is returned.
	 * @param {Zarafa.core.data.SharedComponentType} type Type of component a context can bid for.
	 * @param {Ext.data.Record} record Optionally passed record.
	 * @return {Ext.Component} Component
	 */
	getSharedComponent: function(type, record) {
		var component;
		switch (type) {
			case Zarafa.core.data.SharedComponentType['zarafa.plugins.owncloud.uploadpanel']:
				component = Zarafa.plugins.owncloud.ui.UploadPanel;
				break;
			case Zarafa.core.data.SharedComponentType['zarafa.plugins.owncloud.attachdialog']:
				component = Zarafa.plugins.owncloud.dialogs.AttachFromOwncloudContentPanel;
				break;
			case Zarafa.core.data.SharedComponentType['zarafa.plugins.owncloud.fileinfopanel']:
				component = Zarafa.plugins.owncloud.dialogs.ShowOwncloudFileContentPanel;
				break;
			case Zarafa.core.data.SharedComponentType['common.create']:
				component = Zarafa.plugins.owncloud.dialogs.OwncloudUploadContentPanel;
				break;
			case Zarafa.core.data.SharedComponentType['common.view']:
				component = Zarafa.plugins.owncloud.ui.OwncloudViewPanel;
				break;
			case Zarafa.core.data.SharedComponentType['common.preview']:
				component = Zarafa.plugins.owncloud.ui.OwncloudViewPanel;
				break;
			case Zarafa.core.data.SharedComponentType['common.contextmenu']:
				component = Zarafa.plugins.owncloud.ui.OwncloudFileGridContextMenu;
				break;
		}
		return component;
	},

	/**
	 * Creates the owncloud tree that is shown when the user selects the owncloud context from the
	 * button panel. It shows a tree of available owncloud folders that can be checked and unchecked.
	 * @private
	 */
	createOwncloudNavigationPanel : function() {
		return {
			xtype : 'zarafa.contextnavigation',
			context : this,
			items : [{
				xtype : 'panel',
				cls: 'zarafa-context-navigation-block',
				title : container.getSettingsModel().get('zarafa/v1/plugins/owncloud/button_name'),
				items : [{ 
					xtype: 'zarafa.owncloudtreepanel',
					ref : '../../../owncloudTreepanel'
				}] // add the treeloader here
			}]
		};
	},

	/**
	 * creates a context panel
	 * @return configuration for owncloud context
	 * @private
	 */
	createContentPanel: function() {
		return {
			xtype : 'zarafa.owncloudmainpanel',
			context : this
		};
	},

	/**
	 * Create "New File" {@link Ext.menu.MenuItem item} for the "New item"
	 * {@link Ext.menu.Menu menu} in the {@link Zarafa.core.ui.MainToolbar toolbar}.
	 * This button should be shown in all {@link Zarafa.core.Context contexts} and
	 * is used to create a new Sticky Owncloud.
	 *
	 * @return {Object} The menu item for creating a new Sticky Owncloud item
	 */
	createNewOwncloudButton: function() {
		return {
			xtype: 'menuitem',
			text: dgettext('plugin_owncloud', 'Upload file'),
			iconCls: 'icon_owncloud_category_large',
			newMenuIndex: 6,
			context: this.getName(),
			handler: function() {
				Zarafa.plugins.owncloud.data.Actions.openCreateOwncloudContent(this.getModel());
			},
			scope: this
		};
	},

	/**
	 * Handler for the insertion points for extending the Contacts and AddressBook context menus
	 * with buttons to send a mail to the given Contact and Address Book.
	 * @private
	 */
	createSendEmailContextItem : function() {
		return {
			text : dgettext('plugin_owncloud', 'Send file'),
			iconCls : 'icon_attachment',
			scope : this,
			handler : function(item) {
				Zarafa.plugins.owncloud.data.Actions.openCreateMailContentForContacts(this.getModel(), item.parentMenu.records);
			},
			beforeShow : function(item, records) {
				var visible = false;

				for (var i = 0, len = records.length; i < len; i++) {
					var record = records[i];
					if (this.isSendEmailButtonVisible(record)) {
						visible = true;
						break;
					}
				}

				item.setVisible(visible);
			}
		};
	},

	/**
	 * Handler for the insertion points for extending the Contacts and Distribution Dialogs
	 * with buttons to send a mail to the given Contact or Distribution list.
	 * @private
	 */
	createSendEmailButton : function() {
		return {
			xtype : 'button',
			plugins : [ 'zarafa.recordcomponentupdaterplugin' ],
			iconCls : 'icon_attachment',
			overflowText : dgettext('plugin_owncloud', 'Send file'),
			tooltip : {
				title : dgettext('plugin_owncloud', 'Send file'),
				text : dgettext('plugin_owncloud', 'Create a new email message with some files attached.')
			},
			handler : function(btn) {
				Zarafa.plugins.owncloud.data.Actions.openCreateMailContentForContacts(this.getModel(), btn.record);
			},
			scope : this,
			update : function(record, resetContent) {
				this.record = record;
				if (resetContent) {
					// Smal workaround, update is called from the btn scope,
					// but the handler from the Context scope. So access
					// isSendEmailButtonVisible from the scope.
					if (!this.scope.isSendEmailButtonVisible(record)) {
						this.hide();
					}
				}
			}
		}
	},
	
	/**
	 * Check if the given record (which represents a Contact or Distribution list
	 * can be mailed (this requires the record not to be a {@link Ext.data.Record#phantom}
	 * and the Contact should {@link Zarafa.contact.ContactRecord#hasEmailAddress have an email address}.
	 * @param {Zarafa.core.data.MAPIRecord} record The record to check
	 * @return {Boolean} True if we can send an email to this contact/distlist
	 * @private
	 */
	isSendEmailButtonVisible : function(record) {
		if (record.phantom) {
			return false;
		} else if (record.isMessageClass('IPM.Contact')) {
			if (!record.hasEmailAddress()) {
				return false;
			}
		}

		return true;
	},
	
	/**
	 * Returns the buttons for the dropdown list of the VIEW-button in the main toolbar. It will use the 
	 * main.maintoolbar.view.owncloud insertion point to allow other plugins to add their items at the end.
	 * 
	 * @return {Ext.Component|Array} an array of components
	 */
	getMainToolbarViewButtons : function() {
		var items = container.populateInsertionPoint('main.maintoolbar.view.owncloud', this) || [];
		
		var defaultItems = [{
			overflowText: dgettext('plugin_owncloud', 'No preview'),
			iconCls: 'icon_previewpanel_off',
			text: dgettext('plugin_owncloud', 'No preview'),
			valueView : Zarafa.plugins.owncloud.data.Views.LIST,
			valueViewMode : Zarafa.plugins.owncloud.data.ViewModes.NO_PREVIEW,
			valueDataMode : Zarafa.plugins.owncloud.data.DataModes.ALL,
			handler: this.onContextSelectView,
			scope: this
		},{
			overflowText: dgettext('plugin_owncloud', 'Right preview'),
			iconCls: 'icon_previewpanel_right',
			text: dgettext('plugin_owncloud', 'Right preview'),
			valueView : Zarafa.plugins.owncloud.data.Views.LIST,
			valueViewMode : Zarafa.plugins.owncloud.data.ViewModes.RIGHT_PREVIEW,
			valueDataMode : Zarafa.plugins.owncloud.data.DataModes.ALL,
			handler: this.onContextSelectView,
			scope: this
		},{
			overflowText: dgettext('plugin_owncloud', 'Bottom preview'),
			iconCls: 'icon_previewpanel_bottom',
			text: dgettext('plugin_owncloud', 'Bottom preview'),
			valueView : Zarafa.plugins.owncloud.data.Views.LIST,
			valueViewMode : Zarafa.plugins.owncloud.data.ViewModes.BOTTOM_PREVIEW,
			valueDataMode : Zarafa.plugins.owncloud.data.DataModes.ALL,
			handler: this.onContextSelectView,
			scope: this
		}];

		return defaultItems.concat(items);
	},

	/**
	 * Event handler which is fired when one of the View buttons
	 * has been pressed. This will call {@link #setView setView}
	 * to update the view.
	 * @param {Ext.Button} button The button which was pressed
	 * @private
	 */
	onContextSelectView : function(button) {
		this.getModel().setDataMode(button.valueDataMode);
		this.switchView(button.valueView, button.valueViewMode);
		
		// update the preview panel (redo layout)
		this.getModel().setPreviewRecord(undefined,true);
	},
	
	/**
	 * Adds a button to the top tab bar for this context.
	 * @return {Object} The button for the top tabbar 
	 * @private
	 */
	createMainTab: function() {
		return {
			text: this.getDisplayName(),
			tabOrderIndex: 7,
			context: this.getName()
		};
	},
	
	registerModules: function() {
		Zarafa.core.ModuleNames['IPM.OWNCLOUD'] = {
			list : 'owncloudbrowsermodule',
			item : 'owncloudbrowsermodule'
		}
	}
});
/**
 * OwncloudPlugin.js zarafa owncloud plugin
 *
 * Author: Christoph Haas <christoph.h@sprinternet.at>
 * Copyright (C) 2012-2013 Christoph Haas
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

Ext.namespace('Zarafa.plugins.owncloud');

/**
 * @class Zarafa.plugins.owncloud.OwncloudPlugin
 * @extends Zarafa.core.Plugin
 * This cplugin is used to load the settings widget!
 */
Zarafa.plugins.owncloud.OwncloudPlugin = Ext.extend(Zarafa.core.Plugin, {
	/**
	 * @constructor
	 * @param {Object} config
	 */
	constructor : function(config) {
		config = config || {};
		
		Ext.applyIf(config, {
			name : 'owncloud',
			displayName : dgettext('plugin_owncloud', '+%+ Plugin').replace('+%+', container.getSettingsModel().get('zarafa/v1/plugins/owncloud/button_name')),
			about : Zarafa.plugins.owncloud.ABOUT
		});
		
		Zarafa.plugins.owncloud.OwncloudPlugin.superclass.constructor.call(this, config);
	},

	/**
	 * initialises insertion point for plugin
	 * @protected
	 */
	initPlugin : function() {
		Zarafa.plugins.owncloud.OwncloudPlugin.superclass.initPlugin.apply(this, arguments);
		
		/* Initialise Version Manager */
		Zarafa.plugins.owncloud.data.Version.init();
		
		/* settingswidget */
		/* Register the Mail category for the settings */
		this.registerInsertionPoint('context.settings.categories', this.createSettingCategories, this);
		/* use zarafa user as default user */
		if(container.getSettingsModel().get('zarafa/v1/contexts/owncloud/username') == "defaultusername")
			container.getSettingsModel().set('zarafa/v1/contexts/owncloud/username', container.getUser().getUserName());
			
		/* some init for the context */
		var owncloud_icon = Zarafa.core.mapi.IconIndex.addProperty("owncloud");
		container.getSettingsModel().set('zarafa/v1/contexts/owncloud/iconid', owncloud_icon);
	},
	
	/**
	 * Create the owncloud {@link Zarafa.settings.ui.SettingsCategory Settings Category}
	 * to the {@link Zarafa.settings.SettingsContext}. This will create new
	 * {@link Zarafa.settings.ui.SettingsCategoryTab tabs} for the
	 * {@link Zarafa.plugins.owncloud.settings.SettingsOwncloudCategory Owncloud} and the 
	 * in the {@link Zarafa.settings.ui.SettingsCategoryWidgetPanel Widget Panel}.
	 * @return {Array} configuration object for the categories to register
	 * @private
	 */
	createSettingCategories: function() {
		return [{
			xtype : 'Zarafa.plugins.owncloud.settingsowncloudcategory'
		}]
	}
});

/**
 * registers all plugins and the context
 */
Zarafa.onReady(function() {
	container.registerPlugin(new Zarafa.plugins.owncloud.OwncloudPlugin);
	
	if(container.getSettingsModel().get('zarafa/v1/plugins/owncloud/enable_attach_from_oc') === true)
		container.registerPlugin( new Zarafa.plugins.owncloud.AttachFromOwncloudPlugin);
	if(container.getSettingsModel().get('zarafa/v1/plugins/owncloud/enable_store_to_oc') === true)
		container.registerPlugin( new Zarafa.plugins.owncloud.SaveToOwncloudPlugin);
	if(container.getSettingsModel().get('zarafa/v1/plugins/owncloud/enable_browser') === true)
		container.registerContext(new Zarafa.plugins.owncloud.context.OwncloudContext());
});
